#include "ui_local.h"
#include "gameinfo.h"

float UI_FadeAmount( int startMsec, int totalMsec, int fadeFlag );

int currentDepartment;

static qhandle_t		cornerUpper;

int s_lead_Data[] =
{
	MNT_LEADNAME1,
	MNT_LEADTITLE1,
	MNT_NONE,
	MNT_LEADNAME2,
	MNT_LEADTITLE2,
	MNT_NONE,
	MNT_LEADNAME3,
	MNT_LEADTITLE3,
	MNT_NONE,
	MNT_LEADNAME4,
	MNT_LEADTITLE4,
	MNT_NONE,
	MNT_LEADNAME5,
	MNT_LEADTITLE5,
	MNT_NONE,
	MNT_LEADNAME6,
	MNT_LEADTITLE6,
	MNT_NONE,
	MNT_LEADNAME7,
	MNT_LEADTITLE7,
	MNT_NONE,
	MNT_NONE
};

int s_art_Data[] =
{
	MNT_ARTNAME1,
	MNT_ARTTITLE1,
	MNT_NONE,
	MNT_ARTNAME2,
	MNT_ARTTITLE2,
	MNT_NONE,
	MNT_ARTNAME3,
	MNT_ARTTITLE3,
	MNT_NONE,
	MNT_ARTNAME4,
	MNT_ARTTITLE4,
	MNT_NONE,
	MNT_ARTNAME5,
	MNT_ARTTITLE5,
	MNT_NONE,
	MNT_ARTNAME6,
	MNT_ARTTITLE6,
	MNT_NONE,
	MNT_ARTNAME7,
	MNT_ARTTITLE7,
	MNT_NONE,
	MNT_ARTNAME8,
	MNT_ARTTITLE8,
	MNT_NONE,
	MNT_ARTNAME10,
	MNT_ARTTITLE10,
	MNT_NONE,
	MNT_ARTNAME9,
	MNT_ARTTITLE9,
	MNT_NONE,
	MNT_NONE
};

int s_animation_Data[] =
{
	MNT_ANIMNAME1,
	MNT_ANIMTITLE1,
	MNT_NONE,
	MNT_ANIMNAME2,
	MNT_ANIMTITLE2,
	MNT_NONE,
	MNT_ANIMNAME3,
	MNT_ANIMTITLE3,
	MNT_NONE,
	MNT_ANIMNAME4,
	MNT_ANIMTITLE4,
	MNT_NONE,
	MNT_ANIMNAME5,
	MNT_ANIMTITLE5,
	MNT_NONE,
	MNT_NONE
};


	
int s_designer_Data[] =
{
	MNT_DESIGNERNAME1,
	MNT_DESIGNERTITLE1,
	MNT_NONE,
	MNT_DESIGNERNAME2,
	MNT_DESIGNERTITLE2,
	MNT_NONE,
	MNT_DESIGNERNAME3,
	MNT_DESIGNERTITLE3,
	MNT_NONE,
	MNT_DESIGNERNAME4,
	MNT_DESIGNERTITLE4,
	MNT_NONE,
	MNT_DESIGNERNAME5,
	MNT_DESIGNERTITLE5,
	MNT_NONE,
	MNT_DESIGNERNAME6,
	MNT_DESIGNERTITLE6,
	MNT_NONE,
	MNT_DESIGNERNAME7,
	MNT_DESIGNERTITLE7,
	MNT_NONE,
	MNT_DESIGNERNAME8,
	MNT_DESIGNERTITLE8,
	MNT_NONE,
	MNT_DESIGNERNAME9,
	MNT_DESIGNERTITLE9,
	MNT_NONE,
	MNT_DESIGNERNAME10,
	MNT_DESIGNERTITLE10,
	MNT_NONE,
	MNT_DESIGNERNAME11,
	MNT_DESIGNERTITLE11,
	MNT_NONE,
	MNT_NONE
};

int s_programmer_Data [] =
{
	MNT_PROGRAMMERNAME1,
	MNT_PROGRAMMERTITLE1,
	MNT_NONE,
	MNT_PROGRAMMERNAME3,
	MNT_PROGRAMMERTITLE3,
	MNT_NONE,
	MNT_PROGRAMMERNAME2,
	MNT_PROGRAMMERTITLE2,
	MNT_NONE,
	MNT_PROGRAMMERNAME4,
	MNT_PROGRAMMERTITLE4,
	MNT_NONE,
	MNT_PROGRAMMERNAME5,
	MNT_PROGRAMMERTITLE5,
	MNT_NONE,
	MNT_PROGRAMMERNAME6,
	MNT_PROGRAMMERTITLE6,
	MNT_NONE,
	MNT_PROGRAMMERNAME7,
	MNT_PROGRAMMERTITLE7,
	MNT_NONE,
	MNT_PROGRAMMERNAME8,
	MNT_PROGRAMMERTITLE8,
	MNT_NONE,
	MNT_PROGRAMMERNAME9,
	MNT_PROGRAMMERTITLE9,
	MNT_NONE,
	MNT_PROGRAMMERNAME10,
	MNT_PROGRAMMERTITLE10,
	MNT_NONE,
	MNT_PROGRAMMERNAME11,
	MNT_PROGRAMMERTITLE11,
	MNT_NONE,
	MNT_PROGRAMMERNAME12,
	MNT_PROGRAMMERTITLE12,
	MNT_NONE,
	MNT_PROGRAMMERNAME13,
	MNT_PROGRAMMERTITLE13,
	MNT_NONE,
	MNT_PROGRAMMERNAME14,
	MNT_PROGRAMMERTITLE14,
	MNT_NONE,
	MNT_NONE
};

int s_sound_Data [] =
{
	MNT_SOUNDNAME1,
	MNT_SOUNDTITLE1_1,
	MNT_SOUNDTITLE1_2,
	MNT_SOUNDNAME2,
	MNT_SOUNDTITLE2_1,
	MNT_SOUNDTITLE2_2,
	MNT_SOUNDNAME3,
	MNT_SOUNDTITLE3_1,
	MNT_SOUNDTITLE3_2,
	MNT_NONE
};


int s_support_Data [] =
{
	MNT_SUPPORTNAME1,
	MNT_SUPPORTTITLE1,
	MNT_NONE,
	MNT_SUPPORTNAME2,
	MNT_SUPPORTTITLE2_1,
	MNT_SUPPORTTITLE2_2,
	MNT_NONE
};




typedef struct 
{
	int			department;	
	int			*names;
	int			planetX;
	int			planetY;
	int			labelEnum;
	char		*breakout;		// File name of graphic
	qhandle_t	graphic;	// Handle of graphic
} creditsDepartments_t;

static creditsDepartments_t s_creditsRavenGroup [] =
{
	MNT_LEADSDEPT,			s_lead_Data,		150,	184,	MNT_LEADSDEPT,			"menu/space/planet1.tga",		0,
	MNT_ARTDEPT,			s_art_Data,			290,	370,	MNT_ARTDEPT,			"menu/space/planet3.tga",		0,
	MNT_ANIMATIONDEPT,		s_animation_Data,	200,	220,	MNT_ANIMATIONDEPT,		"menu/space/planet5.tga",		0,
	MNT_DESIGNERDEPT,		s_designer_Data,	138,	316,	MNT_DESIGNERDEPT,		"menu/space/planet7.tga",		0,
	MNT_PROGRAMMINGDEPT,	s_programmer_Data,	274,	178,	MNT_PROGRAMMINGDEPT,	"menu/space/planet9.tga",		0,
	MNT_SOUNDDEPT,			s_sound_Data,		206,	392,	MNT_SOUNDDEPT,			"menu/space/planet2.tga",		0,
	MNT_SUPPORTDEPT,		s_support_Data,		258,	267,	MNT_SUPPORTDEPT,		"menu/space/planet4.tga",		0,	
	MNT_NONE,				NULL,				0,	0,		0,						NULL,							0,
};


int s_production_Data [] =
{
	MNT_PRODUCERNAME1,
	MNT_PRODUCERTITLE1,
	MNT_NONE,
	MNT_PRODUCTIONNAME2,
	MNT_PRODUCTIONTITLE2,
	MNT_NONE,
	MNT_PRODUCTIONNAME3,
	MNT_PRODUCTIONTITLE3,
	MNT_NONE,
	MNT_PRODUCTIONNAME4,
	MNT_PRODUCTIONTITLE4,
	MNT_NONE,
	MNT_NONE
};

int s_custmersupport_Data [] =
{
	MNT_CUSTOMERSUPPORTNAME1,
	MNT_CUSTOMERSUPPORTTITLE1,
	MNT_NONE,
	MNT_CUSTOMERSUPPORTNAME2,
	MNT_CUSTOMERSUPPORTTITLE2,
	MNT_NONE,
	MNT_CUSTOMERSUPPORTNAME3,
	MNT_CUSTOMERSUPPORTTITLE3,
	MNT_NONE,
	MNT_CUSTOMERSUPPORTNAME4,
	MNT_CUSTOMERSUPPORTTITLE3,
	MNT_NONE,
	MNT_NONE
};

int s_usmarketing_Data [] =
{
	MNT_USMARKETINGNAME1,
	MNT_USMARKETINGTITLE1,
	MNT_NONE,
	MNT_USMARKETINGNAME2,
	MNT_USMARKETINGTITLE2,
	MNT_NONE,
	MNT_USMARKETINGNAME3,
	MNT_USMARKETINGTITLE3_1,
	MNT_USMARKETINGTITLE3_2,
	MNT_USMARKETINGNAME4,
	MNT_USMARKETINGTITLE4_1,
	MNT_USMARKETINGTITLE4_2,
	MNT_USMARKETINGNAME5,
	MNT_USMARKETINGTITLE5_1,
	MNT_USMARKETINGTITLE5_2,
	MNT_NONE
};

int s_publicrelations_Data [] =
{	
	MNT_PUBLICRELATIONSNAME1,
	MNT_PUBLICRELATIONSTITLE1,
	MNT_NONE,
	MNT_PUBLICRELATIONSNAME2,
	MNT_PUBLICRELATIONSTITLE2_1,
	MNT_PUBLICRELATIONSTITLE2_2,
	MNT_NONE
};

/*
int s_francemarketing_Data [] =
{
	MNT_FRANCEMARKETINGNAME1,
	MNT_FRANCEMARKETINGTITLE1,
	MNT_NONE,
	MNT_FRANCEMARKETINGNAME2,
	MNT_FRANCEMARKETINGTITLE2,
	MNT_NONE,
	MNT_FRANCEMARKETINGNAME3,
	MNT_FRANCEMARKETINGTITLE3,
	MNT_NONE,
	MNT_NONE
};
*/
int s_international_Data [] =
{
	MNT_INTERNATIONALNAME1,
	MNT_INTERNATIONALTITLE1_1,
	MNT_NONE,
	MNT_INTERNATIONALNAME2,
	MNT_INTERNATIONALTITLE2_1,
	MNT_NONE,
	MNT_INTERNATIONALNAME3,
	MNT_INTERNATIONALTITLE3,
	MNT_NONE,
	MNT_INTERNATIONALNAME4,
	MNT_INTERNATIONALTITLE4,
	MNT_NONE,
	MNT_INTERNATIONALNAME5,
	MNT_INTERNATIONALTITLE5_1,
	MNT_NONE,
	MNT_INTERNATIONALNAME6,
	MNT_INTERNATIONALTITLE6,
	MNT_NONE,
	MNT_INTERNATIONALNAME7,
	MNT_INTERNATIONALTITLE1_7,
	MNT_NONE,
	MNT_FRANCEMARKETINGNAME1,
	MNT_FRANCEMARKETINGTITLE1,
	MNT_NONE,
	MNT_FRANCEMARKETINGNAME2,
	MNT_FRANCEMARKETINGTITLE2,
	MNT_NONE,
	MNT_FRANCEMARKETINGNAME3,
	MNT_FRANCEMARKETINGTITLE3,
	MNT_NONE,

	MNT_INTERNATIONALNAME8,
	MNT_INTERNATIONALTITLE1_8,
	MNT_NONE,
	MNT_INTERNATIONALNAME9,
	MNT_INTERNATIONALTITLE1_9,
	MNT_NONE,

	MNT_NONE
};

int s_localization_Data [] =
{
	MNT_LOCALIZATIONNAME1,
	MNT_LOCALIZATIONTITLE1_1,
	MNT_LOCALIZATIONTITLE1_2,
	MNT_LOCALIZATIONNAME2,
	MNT_LOCALIZATIONTITLE2,
	MNT_NONE,
	MNT_LOCALIZATIONNAME3,
	MNT_LOCALIZATIONTITLE3,
	MNT_NONE,
	MNT_LOCALIZATIONNAME4,
	MNT_LOCALIZATIONTITLE4,
	MNT_NONE,
	MNT_NONE
};

int s_coderelease_Data [] =
{
	MNT_CODERELEASENAME1,
	MNT_CODERELEASETITLE1,
	MNT_NONE,
	MNT_CODERELEASENAME2,
	MNT_CODERELEASETITLE1,
	MNT_NONE,
	MNT_NONE
};

int s_compatability_Data [] =
{
	MNT_COMPATABILITYNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_COMPATABILITYNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};

int s_networklab_Data [] =
{
	MNT_NETWORKLABNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_mis_Data [] =
{
	MNT_MISNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME3,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME4,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME5,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME6,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME7,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME8,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME9,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME10,
	MNT_NONE,
	MNT_NONE,
	MNT_MISNAME11,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_qa_Data [] =
{
	MNT_QANAME1,
	MNT_QATITLE1,
	MNT_NONE,
	MNT_QANAME2,
	MNT_QATITLE2,
	MNT_NONE,
	MNT_QANAME3,
	MNT_QATITLE3,
	MNT_NONE,
	MNT_QANAME4,
	MNT_QATITLE4,
	MNT_NONE,
	MNT_QANAME5,
	MNT_QATITLE5,
	MNT_NONE,
	MNT_QANAME6,
	MNT_QATITLE6,
	MNT_NONE,
	MNT_QANAME7,
	MNT_QATITLE7,
	MNT_NONE,
	MNT_QANAME8,
	MNT_QATITLE8,
	MNT_NONE,
	MNT_QANAME9,
	MNT_QATITLE9,
	MNT_NONE,
	MNT_QANAME10,
	MNT_QATITLE10,
	MNT_NONE,
	MNT_QANAME11,
	MNT_QATITLE11,
	MNT_NONE,
	MNT_QANAME12,
	MNT_QATITLE12,
	MNT_NONE,
	MNT_QANAME13,
	MNT_QATITLE13,
	MNT_NONE,
	MNT_QANAME14,
	MNT_QATITLE14,
	MNT_NONE,
	MNT_QANAME15,
	MNT_QATITLE15,
	MNT_NONE,
	MNT_QANAME16,
	MNT_QATITLE16,
	MNT_NONE,
	MNT_QANAME17,
	MNT_QATITLE17,
	MNT_NONE,
	MNT_QANAME18,
	MNT_QATITLE18,
	MNT_NONE,
	MNT_QANAME19,
	MNT_QATITLE19,
	MNT_NONE,
	MNT_QANAME20,
	MNT_QATITLE20,
	MNT_NONE,
	MNT_QANAME21,
	MNT_QATITLE21,
	MNT_NONE,
	MNT_QANAME22,
	MNT_QATITLE22,
	MNT_NONE,
	MNT_QANAME23,
	MNT_QATITLE23,
	MNT_NONE,
	MNT_QANAME24,
	MNT_QATITLE24,
	MNT_NONE,
	MNT_QANAME25,
	MNT_QATITLE25,
	MNT_NONE,
	MNT_QANAME26,
	MNT_QATITLE25,
	MNT_NONE,

	MNT_NONE
};

int s_installer_Data [] =
{
	MNT_INSTALLERNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_INSTALLERNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_manual_Data [] =
{
	MNT_MANUALNAME1,
	MNT_MANUALTITLE1,
	MNT_NONE,
	MNT_NONE
};

int s_producer_Data [] =
{
	MNT_PRODUCERNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};

	
static creditsDepartments_t s_creditsActivision1Group [] =
{
//MNT_PRODUCERDEPT,			s_producer_Data,		110,	350,	MNT_PRODUCERDEPT,			"menu/space/planet8.tga",	0,
	MNT_PRODUCTIONDEPT,			s_production_Data,		200,	194,	MNT_PRODUCTIONDEPT,			"menu/space/planet10.tga",	0,
	MNT_CUSTOMERSUPPORTDEPT,	s_custmersupport_Data,	290,	254,	MNT_CUSTOMERSUPPORTDEPT,	"menu/space/planet8.tga",	0,
	MNT_USMARKETINGDEPT,		s_usmarketing_Data,		180,	350,	MNT_USMARKETINGDEPT,		"menu/space/planet6.tga",	0,
	MNT_PUBLICRELATIONSDEPT,	s_publicrelations_Data,	240,	215,	MNT_PUBLICRELATIONSDEPT,	"menu/space/planet4.tga",	0,
	MNT_INTERNATIONALDEPT,		s_international_Data,	165,	210,	MNT_INTERNATIONALDEPT,		"menu/space/planet1.tga",	0,
	MNT_LOCALIZATIONDEPT,		s_localization_Data,	250,	310,	MNT_LOCALIZATIONDEPT,		"menu/space/planet3.tga",	0,
	MNT_QADEPT,					s_qa_Data,				120,	172,	MNT_QADEPT,					"menu/space/planet9.tga",	0,
	MNT_CODERELEASEDEPT,		s_coderelease_Data,		120,	225,	MNT_CODERELEASEDEPT,		"menu/space/planet5.tga",	0,
	MNT_COMPATABILITYDEPT,		s_compatability_Data,	210,	250,	MNT_COMPATABILITYDEPT,		"menu/space/planet6.tga",	0,
	MNT_NETWORKLABDEPT,			s_networklab_Data,		240,	390,	MNT_NETWORKLABDEPT,			"menu/space/planet7.tga",	0,
	MNT_INSTALLERDEPT,			s_installer_Data,		290,	180,	MNT_INSTALLERDEPT,			"menu/space/planet2.tga",	0,
	MNT_MANUALDEPT,				s_manual_Data,			290,	350,	MNT_MANUALDEPT,				"menu/space/planet4.tga",	0,
	MNT_MISDEPT,				s_mis_Data,				120,	380,	MNT_MISDEPT,				"menu/space/planet8.tga",	0,
	MNT_NONE,					NULL,					0,		0,		0,							NULL,						0,
};


int s_liasons_Data [] =
{
	MNT_LIASONSNAME1,
	MNT_LIASONSTITLE1_1,
	MNT_LIASONSTITLE1_2,
	MNT_LIASONSNAME2,
	MNT_LIASONSTITLE2_1,
	MNT_LIASONSTITLE2_2,
	MNT_NONE
};
int s_viacom_Data [] =
{
	MNT_VIACOMNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_VIACOMNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_VIACOMNAME3,
	MNT_NONE,
	MNT_NONE,
	MNT_VIACOMNAME4,
	MNT_NONE,
	MNT_NONE,
	MNT_VIACOMNAME5,
	MNT_NONE,
	MNT_NONE,
	MNT_VIACOMNAME6,
	MNT_NONE,
	MNT_NONE,
//	MNT_VIACOMNAME7,
//	MNT_NONE,
//	MNT_NONE,
	MNT_VIACOMNAME9,
	MNT_NONE,
	MNT_NONE,
//	MNT_VIACOMNAME8,
//	MNT_NONE,
//	MNT_NONE,
	MNT_NONE,
};

int s_consultant_Data [] =
{
	MNT_CONSULTANTNAME1,
	MNT_CONSULTANTTITLE1_1,
	MNT_CONSULTANTTITLE1_2,
	MNT_NONE
};

int s_computerAnimation_Data [] =
{
	MNT_CREATNAME1,
	MNT_CREATTITLE1,
	MNT_NONE,
	MNT_CREATNAME2,
	MNT_CREATTITLE2,
	MNT_NONE,
	MNT_CREATNAME3,
	MNT_CREATTITLE3,
	MNT_NONE,
	MNT_CREATNAME4,
	MNT_CREATTITLE4,
	MNT_NONE,
	MNT_CREATNAME5,
	MNT_CREATTITLE5,
	MNT_NONE,
	MNT_CREATNAME6,
	MNT_CREATTITLE6,
	MNT_NONE,
	MNT_CREATNAME7,
	MNT_CREATTITLE7,
	MNT_NONE,
	MNT_CREATNAME8,
	MNT_CREATTITLE8,
	MNT_NONE,
	MNT_CREATNAME9,
	MNT_CREATTITLE9,
	MNT_NONE,
	MNT_CREATNAME10,
	MNT_CREATTITLE10,
	MNT_NONE,
	MNT_CREATNAME11,
	MNT_CREATTITLE11,	
	MNT_NONE,
	MNT_NONE
};

int s_creativeServices_Data [] =
{
	MNT_IGNITEDMINDS_NAME1,
	MNT_IGNITEDMINDS_TITLE1,
	MNT_NONE,
	MNT_IGNITEDMINDS_NAME2,
	MNT_IGNITEDMINDS_TITLE2,
	MNT_NONE,
	MNT_IGNITEDMINDS_NAME3,
	MNT_IGNITEDMINDS_TITLE3,
	MNT_NONE,
	MNT_NONE
};


int s_openingCredits_Data [] =
{
	MNT_OPENINGCREDITS_NAME,
	MNT_OPENINGCREDITS_TITLE1,
	MNT_OPENINGCREDITS_TITLE2,
	MNT_NONE
};

int s_logoSequence_Data [] =
{
	MNT_LOGOSEQUENCE_NAME,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};

static creditsDepartments_t s_creditsAdditionalGroup [] =
{
	MNT_LIASONS,				s_liasons_Data,				250,	340,	MNT_VIACOMPARAMOUNTLIASONS,		"menu/space/planet2.tga",	0,
	MNT_VIACOM,					s_viacom_Data,				220,	300,	MNT_VIACOMDEPT,				"menu/space/planet1.tga",	0,
	MNT_CONSULTANT,				s_consultant_Data,			310,	280,	MNT_CONSULTANT,					"menu/space/planet3.tga",	0,
	MNT_CREATDEPT,				s_computerAnimation_Data,	250,	250,	MNT_COMPUTERRENDEREDANIMATION,	"menu/space/planet6.tga",	0,
	MNT_OPENINGCREDITS,			s_openingCredits_Data,		200,	380,	MNT_OPENINGCREDITSDEPT,			"menu/space/planet4.tga",	0,
	MNT_LOGOSEQUENCE,			s_logoSequence_Data,		160,	205,	MNT_LOGOSEQUENCEDEPT,			"menu/space/planet4.tga",	0,
	MNT_IGNITEDMINDS,			s_creativeServices_Data,	220,	175,	MNT_CREATIVESERVICES,			"menu/space/planet6.tga",	0,
	MNT_NONE,					NULL,						0,		0,		0,								NULL,						0,
};

int s_director_Data [] =
{
	MNT_DIRECTORNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_voyagerCast_Data [] =
{
	MNT_VOYAGERCASTNAME1,
	MNT_VOYAGERCASTTITLE1,
	MNT_NONE,
	MNT_VOYAGERCASTNAME2,
	MNT_VOYAGERCASTTITLE2,
	MNT_NONE,
	MNT_VOYAGERCASTNAME3,
	MNT_VOYAGERCASTTITLE3,
	MNT_NONE,
	MNT_VOYAGERCASTNAME4,
	MNT_VOYAGERCASTTITLE4,
	MNT_NONE,
	MNT_VOYAGERCASTNAME5,
	MNT_VOYAGERCASTTITLE5,
	MNT_NONE,
	MNT_VOYAGERCASTNAME6,
	MNT_VOYAGERCASTTITLE6,
	MNT_NONE,
	MNT_VOYAGERCASTNAME7,
	MNT_VOYAGERCASTTITLE7,
	MNT_NONE,
	MNT_VOYAGERCASTNAME8,
	MNT_VOYAGERCASTTITLE8,
	MNT_NONE,
	MNT_VOYAGERCASTNAME9,
	MNT_VOYAGERCASTTITLE9,
	MNT_NONE,
	MNT_NONE
};

int s_eliteCast_Data [] =
{
	MNT_ELITECASTNAME1,
	MNT_ELITECASTTITLE1,
	MNT_NONE,
	MNT_ELITECASTNAME2,
	MNT_ELITECASTTITLE2,
	MNT_NONE,
	MNT_ELITECASTNAME3,
	MNT_ELITECASTTITLE3,
	MNT_NONE,
	MNT_ELITECASTNAME4,
	MNT_ELITECASTTITLE4,
	MNT_NONE,
	MNT_ELITECASTNAME5,
	MNT_ELITECASTTITLE5,
	MNT_NONE,
	MNT_ELITECASTNAME6,
	MNT_ELITECASTTITLE6,
	MNT_NONE,
	MNT_ELITECASTNAME7,
	MNT_ELITECASTTITLE7,
	MNT_NONE,
	MNT_ELITECASTNAME8,
	MNT_ELITECASTTITLE8,
	MNT_NONE,
	MNT_ELITECASTNAME9,
	MNT_ELITECASTTITLE9,
	MNT_NONE,
	MNT_ELITECASTNAME10,
	MNT_ELITECASTTITLE10,
	MNT_NONE,
	MNT_ELITECASTNAME11,
	MNT_ELITECASTTITLE11,
	MNT_NONE,
	MNT_ELITECASTNAME12,
	MNT_ELITECASTTITLE12,
	MNT_NONE,
	MNT_ELITECASTNAME13,
	MNT_ELITECASTTITLE13,
	MNT_NONE,
	MNT_ELITECASTNAME14,
	MNT_ELITECASTTITLE14,
	MNT_NONE,
	MNT_ELITECASTNAME15,
	MNT_ELITECASTTITLE15,
	MNT_NONE,
	MNT_ELITECASTNAME16,
	MNT_ELITECASTTITLE16,
	MNT_NONE,
	MNT_ELITECASTNAME17,
	MNT_ELITECASTTITLE17,
	MNT_NONE,
	MNT_ELITECASTNAME18,
	MNT_ELITECASTTITLE18,
	MNT_NONE,
	MNT_ELITECASTNAME19,
	MNT_ELITECASTTITLE19,
	MNT_NONE,
	MNT_ELITECASTNAME20,
	MNT_ELITECASTTITLE20,
	MNT_NONE,
	MNT_ELITECASTNAME21,
	MNT_ELITECASTTITLE21,
	MNT_NONE,
	MNT_ELITECASTNAME22,
	MNT_ELITECASTTITLE22,
	MNT_NONE,
	MNT_ELITECASTNAME23,
	MNT_ELITECASTTITLE23,
	MNT_NONE,
	MNT_ELITECASTNAME24,
	MNT_ELITECASTTITLE24,
	MNT_NONE,
	MNT_ELITECASTNAME25,
	MNT_ELITECASTTITLE25,
	MNT_NONE,
	MNT_ELITECASTNAME26,
	MNT_ELITECASTTITLE26,
	MNT_NONE,
	MNT_ELITECASTNAME27,
	MNT_ELITECASTTITLE27,
	MNT_NONE,
	MNT_ELITECASTNAME28,
	MNT_ELITECASTTITLE28,
	MNT_NONE,
	MNT_NONE
};

int s_casting_Data [] =
{
	MNT_CASTINGNAME1,
	MNT_CASTINGTITLE1,
	MNT_NONE,
	MNT_CASTINGNAME2,
	MNT_CASTINGTITLE2,
	MNT_NONE,
	MNT_CASTINGNAME3,
	MNT_CASTINGTITLE3,
	MNT_NONE,
	MNT_CASTINGNAME4,
	MNT_CASTINGTITLE4,
	MNT_NONE,
	MNT_NONE
};

int s_recordedat_Data [] =
{
	MNT_RECORDEDATNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_RECORDEDATNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_RECORDEDATNAME3,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_directorGerman_Data [] =
{
	MNT_GERMAN_DIRECTORNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_voyagerCastGerman_Data [] =
{
	MNT_GERMAN_VOYAGERCASTNAME1,
	MNT_GERMAN_VOYAGERCASTTITLE1,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME2,
	MNT_GERMAN_VOYAGERCASTTITLE2,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME3,
	MNT_GERMAN_VOYAGERCASTTITLE3,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME4,
	MNT_GERMAN_VOYAGERCASTTITLE4,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME5,
	MNT_GERMAN_VOYAGERCASTTITLE5,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME6,
	MNT_GERMAN_VOYAGERCASTTITLE6,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME7,
	MNT_GERMAN_VOYAGERCASTTITLE7,
	MNT_NONE,
	MNT_GERMAN_VOYAGERCASTNAME8,
	MNT_GERMAN_VOYAGERCASTTITLE8,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME20,
	MNT_GERMAN_ELITECASTTITLE20,
	MNT_NONE,
	MNT_NONE
};

int s_eliteCastGerman_Data [] =
{
	MNT_GERMAN_ELITECASTNAME1,
	MNT_GERMAN_ELITECASTTITLE1,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME2,
	MNT_GERMAN_ELITECASTTITLE2,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME3,
	MNT_GERMAN_ELITECASTTITLE3,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME4,
	MNT_GERMAN_ELITECASTTITLE4,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME5,
	MNT_GERMAN_ELITECASTTITLE5,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME6,
	MNT_GERMAN_ELITECASTTITLE6,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME7,
	MNT_GERMAN_ELITECASTTITLE7,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME8,
	MNT_GERMAN_ELITECASTTITLE8,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME9,
	MNT_GERMAN_ELITECASTTITLE9,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME10,
	MNT_GERMAN_ELITECASTTITLE10,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME11,
	MNT_GERMAN_ELITECASTTITLE11,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME12,
	MNT_GERMAN_ELITECASTTITLE12,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME13,
	MNT_GERMAN_ELITECASTTITLE13,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME14,
	MNT_GERMAN_ELITECASTTITLE14,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME15,
	MNT_GERMAN_ELITECASTTITLE15,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME16,
	MNT_GERMAN_ELITECASTTITLE16,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME17,
	MNT_GERMAN_ELITECASTTITLE17,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME18,
	MNT_GERMAN_ELITECASTTITLE18,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME19,
	MNT_GERMAN_ELITECASTTITLE19,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME21,
	MNT_GERMAN_ELITECASTTITLE21,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME22,
	MNT_GERMAN_ELITECASTTITLE22,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME23,
	MNT_GERMAN_ELITECASTTITLE23,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME24,
	MNT_GERMAN_ELITECASTTITLE24,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME25,
	MNT_GERMAN_ELITECASTTITLE25,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME26,
	MNT_GERMAN_ELITECASTTITLE26,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME27,
	MNT_GERMAN_ELITECASTTITLE27,
	MNT_NONE,
	MNT_GERMAN_ELITECASTNAME28,
	MNT_GERMAN_ELITECASTTITLE28,
	MNT_NONE,
	MNT_NONE
};

int s_castingGerman_Data [] =
{
	MNT_GERMAN_CASTINGNAME1,
	MNT_GERMAN_CASTINGTITLE1,
	MNT_NONE,
	MNT_GERMAN_CASTINGNAME2,
	MNT_GERMAN_CASTINGTITLE2,
	MNT_NONE,
	MNT_GERMAN_CASTINGNAME3,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};

int s_recordedatGerman_Data [] =
{
	MNT_GERMAN_RECORDEDATNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};

static creditsDepartments_t s_creditsVoiceGroup [] =
{
	MNT_VOYAGERCASTDEPT,		s_voyagerCast_Data,			180,	295,	MNT_VOYAGERCASTDEPT,		"menu/space/planet7.tga",	0,
	MNT_ELITECASTDEPT,			s_eliteCast_Data,			120,	172,	MNT_ELITECASTDEPT,			"menu/space/planet6.tga",	0,
	MNT_CASTINGDEPT,			s_casting_Data,				240,	200,	MNT_CASTINGDEPT,			"menu/space/planet5.tga",	0,
	MNT_RECORDEDATDEPT,			s_recordedat_Data,			290,	380,	MNT_RECORDEDATDEPT,			"menu/space/planet4.tga",	0,
	MNT_DIRECTORDEPT,			s_director_Data,			120,	320,	MNT_DIRECTORDEPT,			"menu/space/planet9.tga",	0,
	MNT_VOYAGERCASTDEPT,		s_voyagerCastGerman_Data,	280,	305,	MNT_GERMAN_VOYAGERCASTDEPT,	"menu/space/planet6.tga",	0,
	MNT_ELITECASTDEPT,			s_eliteCastGerman_Data,		160,	212,	MNT_GERMAN_ELITECASTDEPT,	"menu/space/planet3.tga",	0,
	MNT_CASTINGDEPT,			s_castingGerman_Data,		250,	245,	MNT_GERMAN_CASTINGDEPT,		"menu/space/planet2.tga",	0,
	MNT_RECORDEDATDEPT,			s_recordedatGerman_Data,	210,	400,	MNT_GERMAN_RECORDEDATDEPT,	"menu/space/planet1.tga",	0,
	MNT_DIRECTORDEPT,			s_directorGerman_Data,		110,	350,	MNT_GERMAN_DIRECTORDEPT,	"menu/space/planet8.tga",	0,
	MNT_NONE,					NULL,						0,		0,		0,							NULL,							0,
};


int s_activision_Data [] =
{
	MNT_ACTIVISIONNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME2,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME3,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME4,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME5,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME6,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME7,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME8,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME12,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME13,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME9,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME10,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME11,
	MNT_NONE,
	MNT_NONE,
	MNT_ACTIVISIONNAME14,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_veryspecialthanks_Data [] =
{
	MNT_VERSPECIALTNAME1,
	MNT_NONE,
	MNT_NONE,
	MNT_NONE
};


int s_xspecialthanks_Data [] =
{
	MNT_XSPECIALTNAME1,
	MNT_XSPECIALTTITLE1,
	MNT_NONE,
	MNT_XSPECIALTNAME2,
	MNT_XSPECIALTTITLE2,
	MNT_NONE,
	MNT_XSPECIALTNAME3,
	MNT_XSPECIALTTITLE3,
	MNT_NONE,
	MNT_XSPECIALTNAME4,
	MNT_XSPECIALTTITLE4,
	MNT_NONE,
	MNT_XSPECIALTNAME15,
	MNT_NONE,
	MNT_NONE,
	MNT_XSPECIALTNAME13,
	MNT_XSPECIALTITLE13,
	MNT_NONE,
	MNT_XSPECIALTNAME14,
	MNT_XSPECIALTITLE13,
	MNT_NONE,
	MNT_XSPECIALTNAME16,
	MNT_NONE,
	MNT_NONE,
	MNT_XSPECIALTNAME17,
	MNT_NONE,
	MNT_NONE,
	MNT_XSPECIALTNAME18,
	MNT_NONE,
	MNT_NONE,
	MNT_XSPECIALTNAME5,
	MNT_XSPECIALTTITLE5,
	MNT_NONE,
	MNT_XSPECIALTNAME6,
	MNT_XSPECIALTTITLE6,
	MNT_NONE,
	MNT_XSPECIALTNAME7,
	MNT_XSPECIALTTITLE7,
	MNT_NONE,
	MNT_XSPECIALTNAME8,
	MNT_XSPECIALTTITLE8,
	MNT_NONE,
	MNT_XSPECIALTNAME9,
	MNT_XSPECIALTTITLE9,
	MNT_NONE,
	MNT_XSPECIALTNAME10,
	MNT_XSPECIALTTITLE10,
	MNT_NONE,
	MNT_XSPECIALTNAME11,
	MNT_XSPECIALTTITLE11,
	MNT_NONE,
//	MNT_XSPECIALTNAME12,
//	MNT_XSPECIALTTITLE12_1,
//	MNT_XSPECIALTTITLE12_2,

	MNT_XSPECIALTNAME19,
	MNT_XSPECIALTTITLE19,
	MNT_NONE,
	MNT_XSPECIALTNAME20,
	MNT_XSPECIALTTITLE20,
	MNT_NONE,
	MNT_XSPECIALTNAME21,
	MNT_XSPECIALTTITLE21,
	MNT_NONE,

	MNT_NONE
};

int s_fansite_Data [] =
{
	MNT_FANSITENAME1,
	MNT_FANSITETITLE1,
	MNT_NONE,
	MNT_FANSITENAME2,
	MNT_FANSITETITLE2,
	MNT_NONE,
	MNT_FANSITENAME3,
	MNT_FANSITETITLE3,
	MNT_NONE,
	MNT_FANSITENAME4,
	MNT_FANSITETITLE4,
	MNT_NONE,
	MNT_FANSITENAME5,
	MNT_NONE,
	MNT_FANSITETITLE5,
	MNT_NONE,
	MNT_NONE
};



static creditsDepartments_t s_creditsThanksGroup [] =
{
//	MNT_VIACOM,						s_viacom_Data,				280,	280,	MNT_VIACOMDEPT,				"menu/space/planet1.tga",	0,
	MNT_ACTIVISIONDEPT,				s_activision_Data,			250,	240,	MNT_ACTIVISIONDEPT,			"menu/space/planet2.tga",	0,
	MNT_SPECIALTHANKS,				s_veryspecialthanks_Data,	120,	280,	MNT_VERYSPECIALTHANKSDEPT,	"menu/space/planet4.tga",	0,
	MNT_SPECIALTHANKS,				s_xspecialthanks_Data,		200,	200,	MNT_XSPECIALTHANKSDEPT,		"menu/space/planet5.tga",	0,
//	MNT_FANSITEDEPT,				s_fansite_Data,				250,	240,	MNT_FANSITEDEPT,			"menu/space/planet6.tga",	0,

	MNT_NONE,						NULL,						0,		0,		0,								NULL,							0,
};
	

typedef struct 
{
	creditsDepartments_t *group;	
	char			*spacemap;		// File name of graphic
	qhandle_t		spacegraphic;		// Handle of graphic
} currentGroup_t;

currentGroup_t *currentGroup;	// Pointer to current group in use

int currentGroupI;		// Pointer of current group in Groups

// All Groups
currentGroup_t Groups [] =
{
s_creditsRavenGroup,				"menu/space/spacemap1.tga",	0,
s_creditsActivision1Group,			"menu/space/spacemap2.tga",	0,
s_creditsAdditionalGroup,			"menu/space/spacemap3.tga",	0,
s_creditsVoiceGroup,				"menu/space/spacemap1.tga",	0,
s_creditsThanksGroup,				"menu/space/spacemap3.tga",	0,
NULL,								NULL,						0
};

typedef enum 
{
	CMG_STARBOX,
	CMG_STARBOXTARGET,
	CMG_PLANET_TARGET,

	CMG_SCALING,

	CMG_PLANET_START,
	CMG_PLANET1,
	CMG_PLANET2,
	CMG_PLANET3,
	CMG_PLANET4,
	CMG_PLANET5,
	CMG_PLANET6,
	CMG_PLANET7,
	CMG_PLANET8,
	CMG_PLANET9,
	CMG_PLANET10,
	CMG_PLANET11,
	CMG_PLANET12,
	CMG_PLANET13,
	CMG_PLANET14,
	CMG_PLANET15,
	CMG_PLANET_END,

	CMG_PLANETLABEL_START,
	CMG_PLANET1_LABEL,
	CMG_PLANET2_LABEL,
	CMG_PLANET3_LABEL,
	CMG_PLANET4_LABEL,
	CMG_PLANET5_LABEL,
	CMG_PLANET6_LABEL,
	CMG_PLANET7_LABEL,
	CMG_PLANET8_LABEL,
	CMG_PLANET9_LABEL,
	CMG_PLANET10_LABEL,
	CMG_PLANET11_LABEL,
	CMG_PLANET12_LABEL,
	CMG_PLANET13_LABEL,
	CMG_PLANET14_LABEL,
	CMG_PLANET15_LABEL,
	CMG_PLANETLABEL_END,

	CMG_PLANETBREAKOUT_START,
	CMG_BREAKOUT1,
	CMG_BREAKOUT2,
	CMG_BREAKOUT3,
	CMG_BREAKOUT4,
	CMG_BREAKOUT5,
	CMG_BREAKOUT6,
	CMG_BREAKOUT7,
	CMG_BREAKOUT8,
	CMG_BREAKOUT9,
	CMG_BREAKOUT10,
	CMG_BREAKOUT11,
	CMG_BREAKOUT12,
	CMG_BREAKOUT13,
	CMG_BREAKOUT14,
	CMG_BREAKOUT15,
	CMG_PLANETBREAKOUT_END,

	CMG_BRACKET,

	CMG_DESC,
	CMG_DESCCLEAR,
	CMG_DESCCURRENT,
	CMG_DESCY,

	CMG_DEPTHEADER,

	CMG_DESC_START,

	CMG_PERSON1,
	CMG_TITLE1_1,
	CMG_TITLE1_2,
	CMG_PERSON2,
	CMG_TITLE2_1,
	CMG_TITLE2_2,
	CMG_PERSON3,
	CMG_TITLE3_1,
	CMG_TITLE3_2,
	CMG_PERSON4,
	CMG_TITLE4_1,
	CMG_TITLE4_2,
	CMG_PERSON5,
	CMG_TITLE5_1,
	CMG_TITLE5_2,

	CMG_DESC_END,

	CMG_LIGHT, 

	CMG_SPACE_MAP,

	CMG_MAX
} creditsmenu_graphics_t;

menugraphics_s creditsmenu_graphics[CMG_MAX] = 
{
//	type		timer	x		y		width	height	file/text								graphic,	min		max	target						inc						style			color
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_STARBOX
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_STARBOXTARGET
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_PLANET_TARGET

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_SCALING

//	type		timer	x		y		width	height	file/text								graphic,	min		max	breakout (target)			label					style			color
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_PLANET_START
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT1,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET1
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT2,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET2
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT3,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET3
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT4,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET4
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT5,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET5
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT6,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET6
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT7,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET7
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT8,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET8
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT9,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET9
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT10,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET10
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT11,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET11
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT12,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET12
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT13,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET13
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT14,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET14
	MG_GRAPHIC,	0.0,	0,		0,		16,		16,		"menu/common/circle2.tga",		0,0,		NULL,		0,		0,	CMG_BREAKOUT15,				0,						0,				CT_MDGREY,	NULL,	// CMG_PLANET15
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_PLANET_END

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,						CT_NONE,	NULL,	// CMG_PLANETLABEL_START
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET1_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET2_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET3_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET4_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET5_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET6_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET7_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET8_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET9_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET10_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET11_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET12_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET13_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET14_LABEL
	MG_STRING,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						UI_CENTER|UI_TINYFONT,	CT_LTBLUE2,NULL,	// CMG_PLANET15_LABEL
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,						CT_NONE,	NULL,	// CMG_PLANETLABEL_END

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_PLANETBREAKOUT_START
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT1
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT2
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT3
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT4
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT5
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT6
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT7
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT8
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT9
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT10
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT11
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT12
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT13
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT14
	MG_GRAPHIC,	0.0,	0,		0,		32,		16,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_WHITE,	NULL,	// CMG_BREAKOUT15
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	0,							0,						0,				CT_NONE,	NULL,	// CMG_PLANETBREAKOUT_END

	MG_GRAPHIC,	0.0,	139,	184,	32,		16,		"menu/space/bracket.tga",		0,0,		NULL,		0,		0,	0,							0,						0,				CT_LTGOLD1,	NULL,	// CMG_BRACKET

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	CMG_DEPTHEADER,				0,						0,				CT_NONE,	NULL,	// CMG_DESC
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	CMG_DEPTHEADER,				0,						0,				CT_NONE,	NULL,	// CMG_DESCCLEAR
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	CMG_DEPTHEADER,				0,						0,				CT_NONE,	NULL,	// CMG_DESCCURRENT
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,	CMG_DEPTHEADER,				0,						0,				CT_NONE,	NULL,	// CMG_DESCY

//	type		timer	x		y		width	height	file/text								graphic,	min			max			target	(next line)			inc						style					color
	MG_STRING,	0.0,	510,	179,	0,		0,		NULL,							0,0,		NULL,		0,		0,			0,							0,					UI_CENTER|UI_BIGFONT,		CT_LTPURPLE2,	NULL,	// CMG_DEPTHEADER

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,			NULL,						0,						0,						CT_NONE,	NULL,		// CMG_DESC_START

//																											start highlighting
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	// CMG_PERSON1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE1_1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE1_2
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	// CMG_PERSON2
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE2_1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE2_2
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	// CMG_PERSON3
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE3_1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE3_2
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	// CMG_PERSON4
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE4_1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE4_2
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	// CMG_PERSON5
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE5_1
	MG_STRING,	0.0,	417,	0,		0,		0,		NULL,							0,0,NULL,		0,					0,					NULL,			0,						UI_TINYFONT,	CT_LTPURPLE1,	NULL,	// CMG_TITLE5_2

//																											start highlighting	max					target						inc						style			color

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,									0,0,NULL,		0,					0,					NULL,						0,						0,				CT_NONE,		NULL,	// CMG_DESC_END

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,									0,0,NULL,		0,					0,					0,							0,						0,				CT_NONE,		NULL,	// CMG_LIGHT

	MG_VAR,		0.0,	87,		169,	512,	256,	NULL,							0,0,		NULL,		0,		0,	CMG_BREAKOUT2,				0,						0,				CT_WHITE,	NULL,	// CMG_SPACE_MAP

};


//===================================================================
//
// Credits Menu
//
//===================================================================

menuframework_s s_credits_menu;
menubitmap_s	s_credits_mainmenu;
menubitmap_s	s_credits_raven;
menubitmap_s	s_credits_activision1;
menubitmap_s	s_credits_additional;
menubitmap_s	s_credits_voice;
menubitmap_s	s_credits_thanks;

#define	ID_MAINMENU				100
#define	ID_RAVEN				101
#define	ID_ACTIVISION1			102
#define	ID_ADDITIONAL			103
#define	ID_VOICE				104
#define	ID_THANKS				105

static void Credits_Restart(void);

/*
===============
M_Credits_Event
===============
*/
void M_Credits_Event (void* ptr, int notification)
{
	if (notification != QM_ACTIVATED)
		return;

	switch (((menucommon_s*)ptr)->id)
	{
		case ID_MAINMENU:
			UI_PopMenu ();
			break;

		case ID_RAVEN:
			currentDepartment = -1;
			currentGroupI = 0;
			currentGroup = &Groups[currentGroupI];
			Credits_Restart();
			break;

		case ID_ACTIVISION1:
			currentDepartment = -1;
			currentGroupI = 1;
			currentGroup = &Groups[currentGroupI];
			Credits_Restart();
			break;

		case ID_ADDITIONAL:
			currentDepartment = -1;
			currentGroupI = 2;
			currentGroup = &Groups[currentGroupI];
			Credits_Restart();
			break;

		case ID_VOICE:
			currentDepartment = -1;
			currentGroupI = 3;
			currentGroup = &Groups[currentGroupI];
			Credits_Restart();
			break;

		case ID_THANKS:
			currentDepartment = -1;
			currentGroupI = 4;
			currentGroup = &Groups[currentGroupI];
			Credits_Restart();
			break;
	}
}

/*
===============
Credits_MenuKey
===============
*/
static sfxHandle_t Credits_MenuKey( int key )
{
	switch ( key )
	{
		case K_KP_LEFTARROW:
		case K_LEFTARROW:
		case K_KP_RIGHTARROW:
		case K_RIGHTARROW:
			key = K_TAB;
			break;
	}

	return ( Menu_DefaultKey( &s_credits_menu, key ) );
}

/*
===============
Credits_GetDeptData
===============
*/
static int Credits_GetDeptData(void)
{
	int CMGi,i;
	int *mntI;

	mntI = (int *) creditsmenu_graphics[CMG_DESC].pointer + creditsmenu_graphics[CMG_DESCCURRENT].target;

	// Clear them out first	
	for (i=CMG_PERSON1;i<(CMG_PERSON1 + 15);i++)
	{
		creditsmenu_graphics[i].color = CT_LTPURPLE1;
		creditsmenu_graphics[i].file = NULL;
	}


	// Nothing left in this department data
	if (*mntI==MNT_NONE)
	{
		return 0;
	}

	CMGi = CMG_PERSON1;
	// Put names and titles in
	for (i=0;i<15;i++,CMGi++)
	{
		if (!(i%3))	// A blank name is the end of the array ( a blank title isn't)
		{	
			if (*mntI == MNT_NONE)	
			{
				creditsmenu_graphics[CMG_DESCCURRENT].target += i;
				return 1;
			}	
		}

		creditsmenu_graphics[CMGi].file = menu_normal_text[*mntI];
		mntI++;
	}

	creditsmenu_graphics[CMG_DESCCURRENT].target += i;
	return 1;

}

/*
===============
Credits_Restart
===============
*/
static void Credits_Restart(void)
{
	int i,planetI,breakoutI,max,color;

	currentDepartment++;
	if (currentGroup->group[currentDepartment].department == NULL)
	{
		currentDepartment = 0;
	}

	planetI = creditsmenu_graphics[CMG_PLANET_TARGET].target = (currentDepartment + CMG_PLANET1);
	breakoutI = creditsmenu_graphics[planetI].target;

	// When first planet should turn white
	creditsmenu_graphics[planetI].timer = uis.realtime + 5000;

	// Turning off menu things
	creditsmenu_graphics[CMG_BRACKET].type = MG_OFF;
	creditsmenu_graphics[CMG_SCALING].type = MG_OFF;
	creditsmenu_graphics[CMG_DESC].type = MG_OFF;
	creditsmenu_graphics[CMG_DESC].target = 0;
	creditsmenu_graphics[CMG_DESC].pointer = currentGroup->group[currentDepartment].names;
	creditsmenu_graphics[CMG_DESCCURRENT].target = 0;
	creditsmenu_graphics[CMG_PERSON1].y = creditsmenu_graphics[CMG_DESCY].y = 213;

	Credits_GetDeptData();

	creditsmenu_graphics[CMG_LIGHT].type = MG_OFF;
	creditsmenu_graphics[CMG_DESCCLEAR].type = MG_OFF;

	// Turn off planet data
	max = CMG_PLANET_END - (CMG_PLANET_START +1);
	for (i=0;i<max;i++)
	{
		creditsmenu_graphics[CMG_PLANET_START +1 + i].type = MG_OFF;		// Turn off planet circle
		creditsmenu_graphics[CMG_PLANETLABEL_START + 1 + i].type = MG_OFF;	// Turn off planet circle
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].type = MG_OFF;// Turn off planet breakout
	}

	// Set up planet data
	for (i=0;i<max;i++)
	{
		if (currentGroup->group[i].planetX == 0)
		{
			break;
		}

		creditsmenu_graphics[CMG_PLANET_START +1 + i].x = currentGroup->group[i].planetX;
		creditsmenu_graphics[CMG_PLANET_START +1 + i].y = currentGroup->group[i].planetY;
		creditsmenu_graphics[CMG_PLANET_START +1 + i].type = MG_GRAPHIC;		// Turn on planet circle
		creditsmenu_graphics[CMG_PLANET_START +1 + i].color = CT_WHITE;		// Make it white 
		creditsmenu_graphics[CMG_PLANETLABEL_START +1 + i].type = MG_STRING;		// Turn on label

		creditsmenu_graphics[CMG_PLANETLABEL_START +1 + i].x = currentGroup->group[i].planetX + 16;
		creditsmenu_graphics[CMG_PLANETLABEL_START +1 + i].y = currentGroup->group[i].planetY + 16;
		creditsmenu_graphics[CMG_PLANETLABEL_START +1 + i].file = menu_normal_text[currentGroup->group[i].labelEnum];

		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].type = MG_OFF;
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].timer = .25;		// Set scale
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].width = creditsmenu_graphics[i].timer * 128;
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].height = creditsmenu_graphics[i].timer * 64;
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].x = currentGroup->group[i].planetX - 12;
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].y = currentGroup->group[i].planetY;
		creditsmenu_graphics[CMG_PLANETBREAKOUT_START +1 + i].graphic = currentGroup->group[i].graphic;
	}

	creditsmenu_graphics[CMG_BRACKET].width = creditsmenu_graphics[breakoutI].timer * 128;
	creditsmenu_graphics[CMG_BRACKET].height = creditsmenu_graphics[breakoutI].timer * 64;

	creditsmenu_graphics[CMG_DEPTHEADER].type = MG_OFF;
	creditsmenu_graphics[CMG_DEPTHEADER].file = menu_normal_text[currentGroup->group[currentDepartment].department];

	for (i=CMG_DESC_START+1;i<CMG_DESC_END;++i)
	{
		creditsmenu_graphics[i].type = MG_OFF;
		creditsmenu_graphics[i].color = CT_LTPURPLE1;
	}

	// Starting point of star box
	creditsmenu_graphics[CMG_STARBOX].x = 99;
	creditsmenu_graphics[CMG_STARBOX].y = 402;

	creditsmenu_graphics[CMG_STARBOXTARGET].x = creditsmenu_graphics[breakoutI].x;
	creditsmenu_graphics[CMG_STARBOXTARGET].y = creditsmenu_graphics[breakoutI].y;

	creditsmenu_graphics[CMG_STARBOX].timer = uis.realtime;
	creditsmenu_graphics[CMG_STARBOX].type = MG_VAR;	// Turn on starbox

	creditsmenu_graphics[CMG_SPACE_MAP].graphic = currentGroup->spacegraphic;	


	if ((currentGroup->group == s_creditsAdditionalGroup) || 
		(currentGroup->group == s_creditsThanksGroup))
	{
		color = CT_LTGOLD1;
	}
	else
	{
		color = CT_LTBLUE2;
	}

	for (i=(CMG_PLANETLABEL_START + 1); i < CMG_PLANETLABEL_END;i++)
	{
		creditsmenu_graphics[i].color = color;
	}
}

/*
===============
Credits_MenuStarBox
===============
*/
static void	Credits_MenuStarBox(void)
{
	int length;
	int	screenTop,boxTop;
	int	screenRight,boxRight;
	int	screenLeft,boxLeft;
	int	screenBottom,boxBottom;
	int boxMiddleX,boxMiddleY;
	int xPos,yPos;
	int xDist,yDist;


	// Time to update starbox position?
	if (creditsmenu_graphics[CMG_STARBOX].timer < uis.realtime)
	{
		// Next time to update
		creditsmenu_graphics[CMG_STARBOX].timer = uis.realtime + 25;

		// Position of upper left corner of box
		xDist = creditsmenu_graphics[CMG_STARBOXTARGET].x - creditsmenu_graphics[CMG_STARBOX].x;
		yDist = creditsmenu_graphics[CMG_STARBOXTARGET].y - creditsmenu_graphics[CMG_STARBOX].y;

		if (xDist > 5)
		{
			creditsmenu_graphics[CMG_STARBOX].x +=5;
		}
		else 
		{
			creditsmenu_graphics[CMG_STARBOX].x =creditsmenu_graphics[CMG_STARBOXTARGET].x;
		}

		if (yDist < -5)
		{
			creditsmenu_graphics[CMG_STARBOX].y -=5;
		}
		else 
		{
			creditsmenu_graphics[CMG_STARBOX].y =creditsmenu_graphics[CMG_STARBOXTARGET].y;
		}
	}
	
	xPos = creditsmenu_graphics[CMG_STARBOX].x;
	yPos = creditsmenu_graphics[CMG_STARBOX].y;

	// Box limits
	boxTop = yPos;
	boxBottom = boxTop + 16;
	boxLeft = xPos;
	boxRight = xPos + 32;

	// Screen limits
	screenTop = 169;
	screenBottom = 419;
	screenRight = 382;
	screenLeft = 93;

	boxMiddleX = boxLeft + 16;
	boxMiddleY = boxTop + 8;


	ui.R_SetColor( colorTable[CT_LTGOLD1]);

	// Lines from the edge of the screen
	length = boxTop - screenTop;	// Line from top 
	UI_DrawHandlePic(boxMiddleX, screenTop,  1,	length, uis.whiteShader);
	length = screenRight - boxRight;	// Line from right
	UI_DrawHandlePic(boxRight, boxMiddleY,  length,	1, uis.whiteShader);
	length = boxLeft - screenLeft;	// Line from left
	UI_DrawHandlePic(screenLeft, boxMiddleY,  length,	1, uis.whiteShader);
	length = screenBottom - boxBottom;	// Line from Bottom
	UI_DrawHandlePic(boxMiddleX, boxBottom,  1,	length, uis.whiteShader);

	// The box
	UI_DrawHandlePic(xPos,		yPos,		32,	1, uis.whiteShader);	// Top line
	UI_DrawHandlePic(xPos,		yPos + 16,	32,	1, uis.whiteShader);	// Bottom line
	UI_DrawHandlePic(xPos,		yPos,		1,	17, uis.whiteShader);	// Left side
	UI_DrawHandlePic(xPos + 32,	yPos,		1,	17, uis.whiteShader);	// Right side

}

/*
===============
Credits_MenuBlinkies
===============
*/
static void	Credits_MenuBlinkies(void)
{
	int i,nameI,planetI,breakoutI,titleI;

	planetI = creditsmenu_graphics[CMG_PLANET_TARGET].target;
	breakoutI= creditsmenu_graphics[planetI].target;

	// Has starbox reached the planet?
	if ((creditsmenu_graphics[CMG_STARBOX].x == creditsmenu_graphics[CMG_STARBOXTARGET].x) &&
		(creditsmenu_graphics[CMG_STARBOX].y == creditsmenu_graphics[CMG_STARBOXTARGET].y) &&
		(creditsmenu_graphics[CMG_STARBOX].type == MG_VAR))
	{
		// Turn on high res picture soon
		creditsmenu_graphics[planetI].timer = uis.realtime + 5;
		creditsmenu_graphics[planetI].type = MG_GRAPHIC;

		creditsmenu_graphics[CMG_STARBOX].type = MG_OFF;	// Turn off starbox
		ui.S_StartLocalSound( menu_out_sound, CHAN_MENU1 );

	}

	// Planet has been bracketed, now turn it off to scale it up
	else if ((creditsmenu_graphics[planetI].timer < uis.realtime) &&
		(creditsmenu_graphics[planetI].type == MG_GRAPHIC))
	{
		creditsmenu_graphics[CMG_BRACKET].type = MG_GRAPHIC;	// Turn on brackets
		creditsmenu_graphics[planetI].type = MG_OFF;		// Turn off planet circle

		creditsmenu_graphics[creditsmenu_graphics[planetI].target].type = MG_GRAPHIC;	// Turn on high res version

		creditsmenu_graphics[breakoutI].timer = .25;		// Set scale

		creditsmenu_graphics[breakoutI].width = creditsmenu_graphics[breakoutI].timer * 128;
		creditsmenu_graphics[breakoutI].height = creditsmenu_graphics[breakoutI].timer * 64;

		creditsmenu_graphics[CMG_BRACKET].width = creditsmenu_graphics[breakoutI].timer * 128;
		creditsmenu_graphics[CMG_BRACKET].height = creditsmenu_graphics[breakoutI].timer * 64;

		creditsmenu_graphics[CMG_SCALING].timer = uis.realtime + 25;	// Set time to start scaling
		creditsmenu_graphics[CMG_SCALING].type = MG_VAR;		// Turn on scaling


		creditsmenu_graphics[CMG_BRACKET].x = creditsmenu_graphics[breakoutI].x;
		creditsmenu_graphics[CMG_BRACKET].y = creditsmenu_graphics[breakoutI].y;

	}

	// Time to make breakout picture bigger
	if ((creditsmenu_graphics[CMG_SCALING].timer < uis.realtime) && 
		(creditsmenu_graphics[CMG_SCALING].type == MG_VAR))
	{

		creditsmenu_graphics[breakoutI].width = creditsmenu_graphics[breakoutI].timer * 128;
		creditsmenu_graphics[breakoutI].height = creditsmenu_graphics[breakoutI].timer * 64;

		creditsmenu_graphics[CMG_BRACKET].width = creditsmenu_graphics[breakoutI].timer * 128;
		creditsmenu_graphics[CMG_BRACKET].height = creditsmenu_graphics[breakoutI].timer * 64;

		// Set time to next bigger scale
		creditsmenu_graphics[CMG_SCALING].timer = uis.realtime + 50;

		// Set size of next scale
		creditsmenu_graphics[breakoutI].timer += 0.05f;

		if (creditsmenu_graphics[breakoutI].timer > 1)	// At full size
		{
			creditsmenu_graphics[CMG_SCALING].type = MG_OFF;			// Turn off scaling
			creditsmenu_graphics[breakoutI].timer = 1;
			creditsmenu_graphics[CMG_DESC].type = MG_VAR;				// Turn on description
			creditsmenu_graphics[CMG_DESC].timer = uis.realtime + 25;	// When to start descriptions
			creditsmenu_graphics[CMG_DESC].target = 0;						// Description to start with

			creditsmenu_graphics[CMG_DEPTHEADER].type = MG_STRING;

		}
	}

	// Print each description line as they are made active
	if ((creditsmenu_graphics[CMG_DESC].timer < uis.realtime) && 
		(creditsmenu_graphics[CMG_DESC].type == MG_VAR))
	{
		// Turn on name
		nameI = creditsmenu_graphics[CMG_DESC].target + CMG_DESC_START + 1;
		creditsmenu_graphics[nameI].type = MG_STRING;

		creditsmenu_graphics[CMG_DESCY].y += 18;	// Next line Y

		ui.S_StartLocalSound( uis.menu_datadisp2_snd, CHAN_MENU1 );

		// Turn on title too, if there is one
		titleI = creditsmenu_graphics[CMG_DESC].target + CMG_DESC_START + 1 + 1;
		if (creditsmenu_graphics[titleI].file)
		{
			creditsmenu_graphics[titleI].type = MG_STRING;
			creditsmenu_graphics[titleI].y = creditsmenu_graphics[CMG_DESCY].y;	
			creditsmenu_graphics[CMG_DESCY].y += 14;	// Next line Y
		}

		// Because Kate Mulgrew's name must be separated out
		if ((currentGroup->group[currentDepartment].names == s_voyagerCast_Data) &&
			(creditsmenu_graphics[titleI].file == menu_normal_text[MNT_VOYAGERCASTTITLE1]))
		{
			creditsmenu_graphics[CMG_DESCY].y += 14;
		}


		// Turn on 2nd title too, if there is one
		titleI = creditsmenu_graphics[CMG_DESC].target + CMG_DESC_START + 1 + 2;
		if (creditsmenu_graphics[titleI].file)
		{
			creditsmenu_graphics[titleI].type = MG_STRING;
			creditsmenu_graphics[titleI].y = creditsmenu_graphics[CMG_DESCY].y;	
			creditsmenu_graphics[CMG_DESCY].y += 14;	// Next line Y
		}

		nameI+=3;

		// Advance to next line of description
		if ((creditsmenu_graphics[nameI].file != NULL) && (nameI < CMG_DESC_END))
		{
			creditsmenu_graphics[CMG_DESCY].y += 2;	// All little additional space before next name
			creditsmenu_graphics[nameI].y = creditsmenu_graphics[CMG_DESCY].y;

			creditsmenu_graphics[CMG_DESC].target += 3;	// Next name
			creditsmenu_graphics[CMG_DESC].timer = uis.realtime + 100;
		}
		else
		{
			// Stop adding lines to description
			creditsmenu_graphics[CMG_DESC].type = MG_OFF;
			// Start lightning names
			creditsmenu_graphics[CMG_LIGHT].target = 0;	// Get 1st name to highlight
			creditsmenu_graphics[CMG_LIGHT].type = MG_VAR;
			creditsmenu_graphics[CMG_LIGHT].timer = uis.realtime + 1000;
		}
	}


	// Lighten each person's name
	if ((creditsmenu_graphics[CMG_LIGHT].timer < uis.realtime) && 
		(creditsmenu_graphics[CMG_LIGHT].type == MG_VAR))
	{
		nameI = creditsmenu_graphics[CMG_LIGHT].target + CMG_DESC_START + 1;
		creditsmenu_graphics[nameI].color = CT_WHITE;

		nameI+=3;

		if ((creditsmenu_graphics[nameI].file != NULL) && (nameI < CMG_DESC_END))
		{
			creditsmenu_graphics[CMG_LIGHT].target += 3;	// Next name
			creditsmenu_graphics[CMG_LIGHT].timer = uis.realtime + 1000;
		}
		else	// Done high lighting names,prepare to print the next batch of names
		{
			creditsmenu_graphics[CMG_LIGHT].type = MG_OFF;		// Turn off highlighting
			creditsmenu_graphics[CMG_DESCCLEAR].type = MG_VAR;	// Turn on description clearing
			creditsmenu_graphics[CMG_DESCCLEAR].timer = uis.realtime + 1500;
		}
	}

	// Clear description text
	if ((creditsmenu_graphics[CMG_DESCCLEAR].timer < uis.realtime) && 
		(creditsmenu_graphics[CMG_DESCCLEAR].type == MG_VAR))
	{
		/// Turn off descriptions
		for (i=CMG_DESC_START+1;i < CMG_DESC_END;++i)
		{
			creditsmenu_graphics[i].type = MG_OFF;
		}

		creditsmenu_graphics[CMG_DESCCLEAR].type = MG_OFF;	// Turn off description clearing
		creditsmenu_graphics[CMG_DESC].timer = uis.realtime + 500;
		creditsmenu_graphics[CMG_DESC].type = MG_VAR;

		// Get next batch of descriptions
		if (Credits_GetDeptData())
		{
			creditsmenu_graphics[CMG_DESC].target = 0;
			creditsmenu_graphics[CMG_DESCY].y = 213;	// Reset Y
		}
		else	// No more descriptions for this category
		{
			Credits_Restart();
		}
	}	
}

/*
===============
Credits_MenuDraw
===============
*/
static void Credits_MenuDraw( void )
{
	UI_MenuFrame(&s_credits_menu);

	Credits_MenuBlinkies();

	ui.R_SetColor( colorTable[CT_DKPURPLE2]);
	UI_DrawHandlePic(30,203,  47, 186, uis.whiteShader);	// Long left hand column square

	ui.R_SetColor( colorTable[CT_WHITE]);
	UI_DrawHandlePic(creditsmenu_graphics[CMG_SPACE_MAP].x,
		creditsmenu_graphics[CMG_SPACE_MAP].y, 
		creditsmenu_graphics[CMG_SPACE_MAP].width,
		creditsmenu_graphics[CMG_SPACE_MAP].height, 
		creditsmenu_graphics[CMG_SPACE_MAP].graphic );

	// Grid over top of space map
	ui.R_SetColor( colorTable[CT_LTBLUE1]);
	UI_DrawHandlePic(  89, 234, 296,   1, uis.whiteShader);
	UI_DrawHandlePic(  89, 296, 296,   1, uis.whiteShader);
	UI_DrawHandlePic(  89, 364, 296,   1, uis.whiteShader);
	UI_DrawHandlePic( 116, 169,   1, 256, uis.whiteShader);
	UI_DrawHandlePic( 234, 169,   1, 256, uis.whiteShader);
	UI_DrawHandlePic( 354, 169,   1, 256, uis.whiteShader);

	//Left Bracket around galaxy picture
	ui.R_SetColor( colorTable[CT_DKPURPLE2]);
	UI_DrawHandlePic(85,169, 16, 16, uis.graphicBracket1CornerLU);
	UI_DrawHandlePic(85,185,  8, 87, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKBROWN1]);
	UI_DrawHandlePic(85,275,  8, 10, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_LTORANGE]);
	UI_DrawHandlePic(87,288,  6, 21, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKBROWN1]);
	UI_DrawHandlePic(85,312,  8, 10, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKPURPLE2]);
	UI_DrawHandlePic(85,325,  8, 87, uis.whiteShader);
	UI_DrawHandlePic(85,412, 16, -16, uis.graphicBracket1CornerLU);	//LD

	//Right Bracket around galaxy picture
	ui.R_SetColor( colorTable[CT_DKPURPLE2]);
	UI_DrawHandlePic(375,169, -16, 16, uis.graphicBracket1CornerLU);	//RU
	UI_DrawHandlePic(383,185,  8, 87, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKBROWN1]);
	UI_DrawHandlePic(383,275,  8, 10, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_LTORANGE]);
	UI_DrawHandlePic(383,288,  6, 21, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKBROWN1]);
	UI_DrawHandlePic(383,312,  8, 10, uis.whiteShader);

	ui.R_SetColor( colorTable[CT_DKPURPLE2]);
	UI_DrawHandlePic(383,325,  8, 87, uis.whiteShader);
	UI_DrawHandlePic(375,412, -16, -16, uis.graphicBracket1CornerLU);	//RD

	// Description frame
	ui.R_SetColor( colorTable[CT_LTBLUE1]);
	UI_DrawHandlePic( 397, 163,  -16,  -16, cornerUpper);	// Top corner
	UI_DrawHandlePic( 397, 418,  -16,   16, cornerUpper);// Bottom Left Corner

	UI_DrawHandlePic(398, 182,  12, 233, uis.whiteShader);	// Block between top & bottom corner

	UI_DrawHandlePic( 412, 169,  10,   7, uis.whiteShader);	// Top line 
	UI_DrawHandlePic( 425, 169, 187,   7, uis.whiteShader);	// Top line 

	UI_DrawHandlePic( 412, 421,  10,   7, uis.whiteShader);	// Top line 
	UI_DrawHandlePic( 425, 421, 187,   7, uis.whiteShader);	// Bottom line 

	// Button round ends
	ui.R_SetColor(colorTable[s_credits_activision1.color]);
	UI_DrawHandlePic(s_credits_raven.generic.x - 14,s_credits_raven.generic.y, 
		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);

	UI_DrawHandlePic(s_credits_activision1.generic.x - 14,s_credits_activision1.generic.y, 
		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);

	UI_DrawHandlePic(s_credits_additional.generic.x - 14,s_credits_additional.generic.y, 
		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);

	UI_DrawHandlePic(s_credits_voice.generic.x - 14,s_credits_voice.generic.y, 
		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);

	UI_DrawHandlePic(s_credits_thanks.generic.x - 14,s_credits_thanks.generic.y, 
		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);


	if (creditsmenu_graphics[CMG_STARBOX].type == MG_VAR)
	{
		Credits_MenuStarBox();
	}

	UI_PrintMenuGraphics(creditsmenu_graphics,CMG_MAX);

	Menu_Draw( &s_credits_menu );
}

/*
===============
UI_CreditsMenu_Cache
===============
*/
void UI_CreditsMenu_Cache(void)
{
	int i,i2;

	cornerUpper= ui.R_RegisterShaderNoMip("menu/common/corner_lr_7_12.tga");

	// Precache all menu graphics in array
	for (i=0;i<CMG_MAX;i++)
	{
		if (creditsmenu_graphics[i].type == MG_GRAPHIC)
		{
			if (creditsmenu_graphics[i].file)
			{
				creditsmenu_graphics[i].graphic = ui.R_RegisterShaderNoMip(creditsmenu_graphics[i].file);
			}
		}
	}

	// Get each groups graphics
	for (i2=0;i2<10;i2++)
	{
		currentGroup = &Groups[i2];
		if (!currentGroup->group)
		{
			break;
		}

		// Get space map
		if (currentGroup->spacemap)
		{
			currentGroup->spacegraphic = ui.R_RegisterShaderNoMip(currentGroup->spacemap);
		}

		// Get breakouts
		for (i=0;i<20;i++)
		{
			if (currentGroup->group[i].planetX == 0)
			{
				break;
			}
			if (currentGroup->group[i].breakout)
			{
				currentGroup->group[i].graphic = ui.R_RegisterShaderNoMip(currentGroup->group[i].breakout);
			}	
		}

	}

	currentDepartment = -1;
	creditsmenu_graphics[CMG_PLANET_TARGET].target = CMG_PLANET1;


	ui.R_RegisterShaderNoMip("menu/space/planet1.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet2.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet3.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet4.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet5.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet6.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet7.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet8.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet9.tga");
	ui.R_RegisterShaderNoMip("menu/space/planet10.tga");

	ui.R_RegisterShaderNoMip("menu/space/spacemap1.tga");
	ui.R_RegisterShaderNoMip("menu/space/spacemap2.tga");
	ui.R_RegisterShaderNoMip("menu/space/spacemap3.tga");
}

/*
===============
CreditsMenu_Init
===============
*/
void CreditsMenu_Init(void)
{
	UI_CreditsMenu_Cache();

	s_credits_menu.nitems					= 0;
	s_credits_menu.draw						= Credits_MenuDraw;
	s_credits_menu.key						= Credits_MenuKey;
	s_credits_menu.fullscreen				= qtrue;
	s_credits_menu.wrapAround				= qtrue;
	s_credits_menu.descX					= MENU_DESC_X;
	s_credits_menu.descY					= MENU_DESC_Y;
	s_credits_menu.titleX					= MENU_TITLE_X;
	s_credits_menu.titleY					= MENU_TITLE_Y;
	s_credits_menu.titleI					= MNT_CREDITSMENU_TITLE;
	s_credits_menu.footNoteEnum				= MNT_CREDITS;

	s_credits_mainmenu.generic.type			= MTYPE_BITMAP;      
	s_credits_mainmenu.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_mainmenu.generic.x			= 482;
	s_credits_mainmenu.generic.y			= 136;
	s_credits_mainmenu.generic.name			= GRAPHIC_BUTTONRIGHT;
	s_credits_mainmenu.generic.id			= ID_MAINMENU;
	s_credits_mainmenu.generic.callback		= M_Credits_Event;
	s_credits_mainmenu.width				= MENU_BUTTON_MED_WIDTH;
	s_credits_mainmenu.height				= MENU_BUTTON_MED_HEIGHT;
	s_credits_mainmenu.color				= CT_DKPURPLE1;
	s_credits_mainmenu.color2				= CT_LTPURPLE1;
	s_credits_mainmenu.textX				= MENU_BUTTON_TEXT_X;
	s_credits_mainmenu.textY				= MENU_BUTTON_TEXT_Y;
	s_credits_mainmenu.textEnum				= MBT_MAINMENU;
	s_credits_mainmenu.textcolor			= CT_BLACK;
	s_credits_mainmenu.textcolor2			= CT_WHITE;

	s_credits_raven.generic.type			= MTYPE_BITMAP;      
	s_credits_raven.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_raven.generic.x				= 100;
	s_credits_raven.generic.y				= 66;
	s_credits_raven.generic.name			= GRAPHIC_BUTTONRIGHT;
	s_credits_raven.generic.id				= ID_RAVEN;
	s_credits_raven.generic.callback		= M_Credits_Event;
	s_credits_raven.width					= MENU_BUTTON_MED_WIDTH + 20;
	s_credits_raven.height					= MENU_BUTTON_MED_HEIGHT;
	s_credits_raven.color					= CT_DKPURPLE1;
	s_credits_raven.color2					= CT_LTPURPLE1;
	s_credits_raven.textX					= MENU_BUTTON_TEXT_X;
	s_credits_raven.textY					= MENU_BUTTON_TEXT_Y;
	s_credits_raven.textEnum				= MBT_RAVENSOFTWARE;
	s_credits_raven.textcolor				= CT_BLACK;
	s_credits_raven.textcolor2				= CT_WHITE;

	s_credits_activision1.generic.type			= MTYPE_BITMAP;      
	s_credits_activision1.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_activision1.generic.x				= 100;
	s_credits_activision1.generic.y				= 88;
	s_credits_activision1.generic.name			= GRAPHIC_BUTTONRIGHT;
	s_credits_activision1.generic.id			= ID_ACTIVISION1;
	s_credits_activision1.generic.callback		= M_Credits_Event;
	s_credits_activision1.width					= MENU_BUTTON_MED_WIDTH + 20;
	s_credits_activision1.height				= MENU_BUTTON_MED_HEIGHT;
	s_credits_activision1.color					= CT_DKPURPLE1;
	s_credits_activision1.color2				= CT_LTPURPLE1;
	s_credits_activision1.textX					= MENU_BUTTON_TEXT_X;
	s_credits_activision1.textY					= MENU_BUTTON_TEXT_Y;
	s_credits_activision1.textEnum				= MBT_ACTIVISION1;
	s_credits_activision1.textcolor				= CT_BLACK;
	s_credits_activision1.textcolor2			= CT_WHITE;

	s_credits_additional.generic.type		= MTYPE_BITMAP;      
	s_credits_additional.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_additional.generic.x			= 280;
	s_credits_additional.generic.y			= 66;
	s_credits_additional.generic.name		= GRAPHIC_BUTTONRIGHT;
	s_credits_additional.generic.id		= ID_ADDITIONAL;
	s_credits_additional.generic.callback	= M_Credits_Event;
	s_credits_additional.width				= MENU_BUTTON_MED_WIDTH + 20;
	s_credits_additional.height			= MENU_BUTTON_MED_HEIGHT;
	s_credits_additional.color				= CT_DKPURPLE1;
	s_credits_additional.color2			= CT_LTPURPLE1;
	s_credits_additional.textX				= MENU_BUTTON_TEXT_X;
	s_credits_additional.textY				= MENU_BUTTON_TEXT_Y;
	s_credits_additional.textEnum			= MBT_ADDITIONAL;
	s_credits_additional.textcolor			= CT_BLACK;
	s_credits_additional.textcolor2		= CT_WHITE;

	s_credits_voice.generic.type		= MTYPE_BITMAP;      
	s_credits_voice.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_voice.generic.x			= 280;
	s_credits_voice.generic.y			= 88;
	s_credits_voice.generic.name		= GRAPHIC_BUTTONRIGHT;
	s_credits_voice.generic.id		= ID_VOICE;
	s_credits_voice.generic.callback	= M_Credits_Event;
	s_credits_voice.width				= MENU_BUTTON_MED_WIDTH + 20;
	s_credits_voice.height			= MENU_BUTTON_MED_HEIGHT;
	s_credits_voice.color				= CT_DKPURPLE1;
	s_credits_voice.color2			= CT_LTPURPLE1;
	s_credits_voice.textX				= MENU_BUTTON_TEXT_X;
	s_credits_voice.textY				= MENU_BUTTON_TEXT_Y;
	s_credits_voice.textEnum			= MBT_VOICETALENTS;
	s_credits_voice.textcolor			= CT_BLACK;
	s_credits_voice.textcolor2		= CT_WHITE;

	s_credits_thanks.generic.type		= MTYPE_BITMAP;      
	s_credits_thanks.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
	s_credits_thanks.generic.x			= 460;
	s_credits_thanks.generic.y			= 66;
	s_credits_thanks.generic.name		= GRAPHIC_BUTTONRIGHT;
	s_credits_thanks.generic.id		= ID_THANKS;
	s_credits_thanks.generic.callback	= M_Credits_Event;
	s_credits_thanks.width				= MENU_BUTTON_MED_WIDTH + 20;
	s_credits_thanks.height			= MENU_BUTTON_MED_HEIGHT;
	s_credits_thanks.color				= CT_DKPURPLE1;
	s_credits_thanks.color2			= CT_LTPURPLE1;
	s_credits_thanks.textX				= MENU_BUTTON_TEXT_X;
	s_credits_thanks.textY				= MENU_BUTTON_TEXT_Y;
	s_credits_thanks.textEnum			= MBT_THANKS;
	s_credits_thanks.textcolor			= CT_BLACK;
	s_credits_thanks.textcolor2		= CT_WHITE;

	Menu_AddItem( &s_credits_menu,	&s_credits_mainmenu );
	Menu_AddItem( &s_credits_menu,	&s_credits_raven );
	Menu_AddItem( &s_credits_menu,	&s_credits_activision1 );
	Menu_AddItem( &s_credits_menu,	&s_credits_additional );
	Menu_AddItem( &s_credits_menu,	&s_credits_voice );
	Menu_AddItem( &s_credits_menu,	&s_credits_thanks );

	creditsmenu_graphics[CMG_PLANET_TARGET].target = CMG_PLANET_START + 1;
	currentGroupI = 0;
	currentGroup = &Groups[currentGroupI];
	currentDepartment = -1;

	Credits_Restart();


}

/*
===============
UI_CreditsMenu
===============
*/
void UI_CreditsMenu(void)
{

	CreditsMenu_Init(); 

	UI_PushMenu( &s_credits_menu );
}

// Data for Closing Credits Menu
static struct 
{
	menuframework_s menu;
	int				currentScreen;
	int				timer;
	int				maxScreens;
//	sfxHandle_t		song;
	int				fromMenu;
	qboolean		musicStart;
} s_closingcredits;

typedef enum 
{
	ECG_SCREEN1,
	ECG_SCREEN2,
	ECG_SCREEN3,
	ECG_SCREEN4,
	ECG_SCREEN5,
	ECG_SCREEN6,
	ECG_SCREEN7,
	ECG_SCREEN8,
	ECG_SCREEN9,
	ECG_SCREEN10,
	ECG_SCREEN10_0,
	ECG_SCREEN11,
	ECG_SCREEN12,
	ECG_SCREEN13,
	ECG_SCREEN14,
	ECG_SCREEN15,
	ECG_SCREEN16,
	ECG_SCREEN17,
	ECG_SCREEN18,
	ECG_SCREEN19,
	ECG_SCREEN37,
	ECG_SCREEN19_0,
	ECG_SCREEN19_1,
	ECG_SCREEN19_2,
	ECG_SCREEN19_3,
	ECG_SCREEN19_4,
	ECG_SCREEN19_5,
	ECG_SCREEN19_6,
	ECG_SCREEN19_7,
	ECG_SCREEN19_8,
	ECG_SCREEN19_9,
	ECG_SCREEN19_10,
	ECG_SCREEN19_11,
	ECG_SCREEN19_12,
	ECG_SCREEN19_13,
	ECG_SCREEN19_14,
	ECG_SCREEN19_15,
	ECG_SCREEN19_15_5,
	ECG_SCREEN19_16,
	ECG_SCREEN19_17,
	ECG_SCREEN37_1,
	ECG_SCREEN20,
	ECG_SCREEN21,
	ECG_SCREEN22,
	ECG_SCREEN23,
	ECG_SCREEN24,
	ECG_SCREEN25,
	ECG_SCREEN26,
	ECG_SCREEN27,
	ECG_SCREEN28,
	ECG_SCREEN29,
	ECG_SCREEN29_5,
	ECG_SCREEN30,
	ECG_SCREEN31,
	ECG_SCREEN32,
	ECG_SCREEN33,
	ECG_SCREEN33_5,
	ECG_SCREEN33_8,
	ECG_SCREEN33_9,
	ECG_SCREEN34,
	ECG_SCREEN35,
	ECG_SCREEN35_5,
	ECG_SCREEN36,
	ECG_SCREEN38,
	ECG_SCREEN38_5,
	ECG_SCREEN39,
	ECG_SCREEN40,
	ECG_SCREEN41,

	ECG_FADE,
	ECG_FADEFLAG,

	ECG_SCREEN1_START,
	ECG_OPENING1LINE1,
	ECG_OPENING1LINE2,
	ECG_OPENING1LINE3,
	ECG_SCREEN1_END,

	ECG_SCREEN2_START,
	ECG_OPENING2LINE1,
	ECG_SCREEN2_END,

	ECG_SCREEN3_START,
	ECG_ACTOR1LINE1,
	ECG_ACTOR1LINE2,
	ECG_ACTOR1LINE3,
	ECG_SCREEN3_END,

	ECG_SCREEN4_START,
	ECG_ACTOR2LINE1,
	ECG_ACTOR2LINE2,
	ECG_ACTOR2LINE3,
	ECG_SCREEN4_END,

	ECG_SCREEN5_START,
	ECG_ACTOR3LINE1,
	ECG_ACTOR3LINE2,
	ECG_ACTOR3LINE3,
	ECG_SCREEN5_END,

	ECG_SCREEN6_START,
	ECG_ACTOR4LINE1,
	ECG_ACTOR4LINE2,
	ECG_ACTOR4LINE3,
	ECG_SCREEN6_END,

	ECG_SCREEN7_START,
	ECG_ACTOR5LINE1,
	ECG_ACTOR5LINE2,
	ECG_ACTOR5LINE3,
	ECG_SCREEN7_END,

	ECG_SCREEN8_START,
	ECG_ACTOR6LINE1,
	ECG_ACTOR6LINE2,
	ECG_ACTOR6LINE3,
	ECG_SCREEN8_END,

	ECG_SCREEN9_START,
	ECG_ACTOR7LINE1,
	ECG_ACTOR7LINE2,
	ECG_ACTOR7LINE3,
	ECG_SCREEN9_END,

	ECG_SCREEN10_START,
	ECG_ACTOR8LINE1,
	ECG_ACTOR8LINE2,
	ECG_ACTOR8LINE3,
	ECG_SCREEN10_END,

	ECG_SCREEN10_0_START,
	ECG_ACTOR10_0_LINE1,
	ECG_ACTOR10_0_LINE2,
	ECG_ACTOR10_0_LINE3,
	ECG_SCREEN10_0_END,

	ECG_SCREEN11_START,
	ECG_ACTOR9LINE1,
	ECG_ACTOR9LINE2,
	ECG_ACTOR9LINE3,
	ECG_SCREEN11_END,

	ECG_SCREEN12_START,
	ECG_ACTOR10LINE1,
	ECG_ACTOR10LINE2,
	ECG_ACTOR10LINE3,
	ECG_SCREEN12_END,

	ECG_SCREEN13_START,
	ECG_ACTOR11LINE1,
	ECG_ACTOR11LINE2,
	ECG_ACTOR11LINE3,
	ECG_SCREEN13_END,

	ECG_SCREEN14_START,
	ECG_ACTOR12LINE1,
	ECG_ACTOR12LINE2,
	ECG_ACTOR12LINE3,
	ECG_SCREEN14_END,

	ECG_SCREEN15_START,
	ECG_ACTOR13LINE1,
	ECG_ACTOR13LINE2,
	ECG_ACTOR13LINE3,
	ECG_SCREEN15_END,

	ECG_SCREEN16_START,
	ECG_ACTOR14LINE1,
	ECG_ACTOR14LINE2,
	ECG_ACTOR14LINE3,
	ECG_SCREEN16_END,

	ECG_SCREEN17_START,
	ECG_ACTOR15LINE1,
	ECG_ACTOR15LINE2,
	ECG_ACTOR15LINE3,
	ECG_SCREEN17_END,

	ECG_SCREEN18_START,
	ECG_ACTOR15LINE1_1,
	ECG_ACTOR15LINE1_2,
	ECG_ACTOR16LINE1_1,
	ECG_ACTOR16LINE1_2,
	ECG_ACTOR17LINE1_1,
	ECG_ACTOR17LINE1_2,
	ECG_ACTOR18LINE1_1,
	ECG_ACTOR18LINE1_2,
	ECG_ACTOR19LINE1_1,
	ECG_ACTOR19LINE1_2,
	ECG_ACTOR20LINE1_1,
	ECG_ACTOR20LINE1_2,
	ECG_ACTOR21LINE1_1,
	ECG_ACTOR21LINE1_2,
	ECG_ACTOR22LINE1_1,
	ECG_ACTOR22LINE1_2,
	ECG_ACTOR23LINE1_1,
	ECG_ACTOR23LINE1_2,
	ECG_ACTOR24LINE1_1,
	ECG_ACTOR24LINE1_2,
	ECG_SCREEN18_END,

	ECG_SCREEN19_START,
	ECG_ACTOR25LINE1_1,
	ECG_ACTOR25LINE1_2,
	ECG_ACTOR26LINE1_1,
	ECG_ACTOR26LINE1_2,
	ECG_ACTOR27LINE1_1,
	ECG_ACTOR27LINE1_2,
	ECG_ACTOR28LINE1_1,
	ECG_ACTOR28LINE1_2,
	ECG_ACTOR29LINE1_1,
	ECG_ACTOR29LINE1_2,
	ECG_ACTOR30LINE1_1,
	ECG_ACTOR30LINE1_2,
	ECG_ACTOR31LINE1_1,
	ECG_ACTOR31LINE1_2,
	ECG_ACTOR32LINE1_1,
	ECG_ACTOR32LINE1_2,
	ECG_ACTOR33LINE1_1,
	ECG_ACTOR33LINE1_2,
	ECG_ACTOR34LINE1_1,
	ECG_ACTOR34LINE1_2,
	ECG_ACTOR35LINE1_1,
	ECG_ACTOR35LINE1_2,
	ECG_SCREEN19_END,

	ECG_SCREEN19_0_START,
	ECG_GERMAN_ACTORS,
	ECG_GERMAN_ACTORS2,
	ECG_SCREEN19_0_END,

	ECG_SCREEN19_1_START,
	ECG_GERMAN_ACTOR1LINE1,
	ECG_GERMAN_ACTOR1LINE2,
	ECG_GERMAN_ACTOR1LINE3,
	ECG_SCREEN19_1_END,

	ECG_SCREEN19_2_START,
	ECG_GERMAN_ACTOR2LINE1,
	ECG_GERMAN_ACTOR2LINE2,
	ECG_GERMAN_ACTOR2LINE3,
	ECG_SCREEN19_2_END,

	ECG_SCREEN19_3_START,
	ECG_GERMAN_ACTOR3LINE1,
	ECG_GERMAN_ACTOR3LINE2,
	ECG_GERMAN_ACTOR3LINE3,
	ECG_SCREEN19_3_END,

	ECG_SCREEN19_4_START,
	ECG_GERMAN_ACTOR4LINE1,
	ECG_GERMAN_ACTOR4LINE2,
	ECG_GERMAN_ACTOR4LINE3,
	ECG_SCREEN19_4_END,

	ECG_SCREEN19_5_START,
	ECG_GERMAN_ACTOR5LINE1,
	ECG_GERMAN_ACTOR5LINE2,
	ECG_GERMAN_ACTOR5LINE3,
	ECG_SCREEN19_5_END,

	ECG_SCREEN19_6_START,
	ECG_GERMAN_ACTOR6LINE1,
	ECG_GERMAN_ACTOR6LINE2,
	ECG_GERMAN_ACTOR6LINE3,
	ECG_SCREEN19_6_END,

	ECG_SCREEN19_7_START,
	ECG_GERMAN_ACTOR7LINE1,
	ECG_GERMAN_ACTOR7LINE2,
	ECG_GERMAN_ACTOR7LINE3,
	ECG_SCREEN19_7_END,

	ECG_SCREEN19_8_START,
	ECG_GERMAN_ACTOR8LINE1,
	ECG_GERMAN_ACTOR8LINE2,
	ECG_GERMAN_ACTOR8LINE3,
	ECG_SCREEN19_8_END,

	ECG_SCREEN19_9_START,
	ECG_GERMAN_ACTOR9LINE1,
	ECG_GERMAN_ACTOR9LINE2,
	ECG_GERMAN_ACTOR9LINE3,
	ECG_SCREEN19_9_END,

	ECG_SCREEN19_10_START,
	ECG_GERMAN_ACTOR10LINE1,
	ECG_GERMAN_ACTOR10LINE2,
	ECG_GERMAN_ACTOR10LINE3,
	ECG_SCREEN19_10_END,

	ECG_SCREEN19_11_START,
	ECG_GERMAN_ACTOR11LINE1,
	ECG_GERMAN_ACTOR11LINE2,
	ECG_GERMAN_ACTOR11LINE3,
	ECG_SCREEN19_11_END,

	ECG_SCREEN19_12_START,
	ECG_GERMAN_ACTOR12LINE1,
	ECG_GERMAN_ACTOR12LINE2,
	ECG_GERMAN_ACTOR12LINE3,
	ECG_SCREEN19_12_END,

	ECG_SCREEN19_13_START,
	ECG_GERMAN_ACTOR13LINE1,
	ECG_GERMAN_ACTOR13LINE2,
	ECG_GERMAN_ACTOR13LINE3,
	ECG_SCREEN19_13_END,

	ECG_SCREEN19_14_START,
	ECG_GERMAN_ACTOR14LINE1,
	ECG_GERMAN_ACTOR14LINE2,
	ECG_GERMAN_ACTOR14LINE3,
	ECG_SCREEN19_14_END,

	ECG_SCREEN19_15_START,
	ECG_GERMAN_ACTOR15LINE1,
	ECG_GERMAN_ACTOR15LINE2,
	ECG_GERMAN_ACTOR15LINE3,
	ECG_SCREEN19_15_END,

	ECG_SCREEN19_15_5_START,
	ECG_GERMAN_ACTOR20LINE1,
	ECG_GERMAN_ACTOR20LINE2,
	ECG_GERMAN_ACTOR20LINE3,
	ECG_SCREEN19_15_5_END,

	ECG_SCREEN19_16_START,
	ECG_GERMAN_ACTOR15LINE1_1,
	ECG_GERMAN_ACTOR15LINE1_2,
	ECG_GERMAN_ACTOR16LINE1_1,
	ECG_GERMAN_ACTOR16LINE1_2,
	ECG_GERMAN_ACTOR17LINE1_1,
	ECG_GERMAN_ACTOR17LINE1_2,
	ECG_GERMAN_ACTOR18LINE1_1,
	ECG_GERMAN_ACTOR18LINE1_2,
	ECG_GERMAN_ACTOR19LINE1_1,
	ECG_GERMAN_ACTOR19LINE1_2,
	ECG_GERMAN_ACTOR20LINE1_1,
	ECG_GERMAN_ACTOR20LINE1_2,
	ECG_GERMAN_ACTOR21LINE1_1,
	ECG_GERMAN_ACTOR21LINE1_2,
	ECG_GERMAN_ACTOR22LINE1_1,
	ECG_GERMAN_ACTOR22LINE1_2,
	ECG_GERMAN_ACTOR23LINE1_1,
	ECG_GERMAN_ACTOR23LINE1_2,
	ECG_GERMAN_ACTOR24LINE1_1,
	ECG_GERMAN_ACTOR24LINE1_2,
	ECG_SCREEN19_16_END,

	ECG_SCREEN19_17_START,
	ECG_GERMAN_ACTOR25LINE1_1,
	ECG_GERMAN_ACTOR25LINE1_2,
	ECG_GERMAN_ACTOR26LINE1_1,
	ECG_GERMAN_ACTOR26LINE1_2,
	ECG_GERMAN_ACTOR27LINE1_1,
	ECG_GERMAN_ACTOR27LINE1_2,
	ECG_GERMAN_ACTOR28LINE1_1,
	ECG_GERMAN_ACTOR28LINE1_2,
	ECG_GERMAN_ACTOR29LINE1_1,
	ECG_GERMAN_ACTOR29LINE1_2,
	ECG_GERMAN_ACTOR30LINE1_1,
	ECG_GERMAN_ACTOR30LINE1_2,
	ECG_GERMAN_ACTOR31LINE1_1,
	ECG_GERMAN_ACTOR31LINE1_2,
	ECG_GERMAN_ACTOR32LINE1_1,
	ECG_GERMAN_ACTOR32LINE1_2,
	ECG_GERMAN_ACTOR33LINE1_1,
	ECG_GERMAN_ACTOR33LINE1_2,
	ECG_GERMAN_ACTOR34LINE1_1,
	ECG_GERMAN_ACTOR34LINE1_2,
	ECG_SCREEN19_17_END,

	ECG_SCREEN20_START,
	ECG_LEADTITLE,
	ECG_LEAD1LINE1,
	ECG_LEAD1LINE2,
	ECG_LEAD2LINE1,
	ECG_LEAD2LINE2,
	ECG_SCREEN20_END,

	ECG_SCREEN21_START,
	ECG_LEAD3LINE1,
	ECG_LEAD3LINE2,
	ECG_SCREEN21_END,

	ECG_SCREEN22_START,
	ECG_LEAD4LINE1,
	ECG_LEAD4LINE2,
	ECG_LEAD5LINE1,
	ECG_LEAD5LINE2,
	ECG_LEAD6LINE1,
	ECG_LEAD6LINE2,
	ECG_LEAD7LINE1,
	ECG_LEAD7LINE2,
	ECG_SCREEN22_END,

	ECG_SCREEN23_START,
	ECG_ARTIST1LINE1,
	ECG_ARTIST1LINE2,
	ECG_ARTIST2LINE1,
	ECG_ARTIST2LINE2,
	ECG_ARTIST3LINE1,
	ECG_ARTIST3LINE2,
	ECG_ARTIST4LINE1,
	ECG_ARTIST4LINE2,
	ECG_ARTIST5LINE1,
	ECG_ARTIST5LINE2,
	ECG_ARTIST6LINE1,
	ECG_ARTIST6LINE2,
	ECG_ARTIST7LINE1,
	ECG_ARTIST7LINE2,
	ECG_ARTIST8LINE1,
	ECG_ARTIST8LINE2,
	ECG_ARTIST9LINE1,
	ECG_ARTIST9LINE2,
	ECG_ARTIST10LINE1,
	ECG_ARTIST10LINE2,
	ECG_SCREEN23_END,

	ECG_SCREEN24_START,
	ECG_MODELER1LINE1,
	ECG_MODELER1LINE2,
	ECG_MODELER2LINE1,
	ECG_MODELER2LINE2,
	ECG_MODELER3LINE1,
	ECG_MODELER3LINE2,
	ECG_MODELER4LINE1,
	ECG_MODELER4LINE2,
	ECG_MODELER5LINE1,
	ECG_MODELER5LINE2,
	ECG_SCREEN24_END,

	ECG_SCREEN25_START,
	ECG_DESIGNERDEPT1,
	ECG_DESIGNER1LINE1,
	ECG_DESIGNER1LINE2,
	ECG_DESIGNER2LINE1,
	ECG_DESIGNER2LINE2,
	ECG_DESIGNER3LINE1,
	ECG_DESIGNER3LINE2,
	ECG_DESIGNER4LINE1,
	ECG_DESIGNER4LINE2,
	ECG_DESIGNER5LINE1,
	ECG_DESIGNER5LINE2,
	ECG_DESIGNER6LINE1,
	ECG_DESIGNER6LINE2,
	ECG_SCREEN25_END,

	ECG_SCREEN26_START,
	ECG_DESIGNERDEPT2,
	ECG_DESIGNER7LINE1,
	ECG_DESIGNER7LINE2,
	ECG_DESIGNER8LINE1,
	ECG_DESIGNER8LINE2,
	ECG_DESIGNER9LINE1,
	ECG_DESIGNER9LINE2,
	ECG_DESIGNER10LINE1,
	ECG_DESIGNER10LINE2,
	ECG_DESIGNER11LINE1,
	ECG_DESIGNER11LINE2,
	ECG_SCREEN26_END,

	ECG_SCREEN27_START,
	ECG_PROGRAMMERDEPT1,
	ECG_PROGRAMMER1LINE1,
	ECG_PROGRAMMER1LINE2,
	ECG_PROGRAMMER2LINE1,
	ECG_PROGRAMMER2LINE2,
	ECG_PROGRAMMER3LINE1,
	ECG_PROGRAMMER3LINE2,
	ECG_PROGRAMMER4LINE1,
	ECG_PROGRAMMER4LINE2,
	ECG_PROGRAMMER5LINE1,
	ECG_PROGRAMMER5LINE2,
	ECG_PROGRAMMER6LINE1,
	ECG_PROGRAMMER6LINE2,
	ECG_SCREEN27_END,

	ECG_SCREEN28_START,
	ECG_PROGRAMMERDEPT2,
	ECG_PROGRAMMER7LINE1,
	ECG_PROGRAMMER7LINE2,
	ECG_PROGRAMMER8LINE1,
	ECG_PROGRAMMER8LINE2,
	ECG_PROGRAMMER9LINE1,
	ECG_PROGRAMMER9LINE2,
	ECG_PROGRAMMER10LINE1,
	ECG_PROGRAMMER10LINE2,
	ECG_PROGRAMMER14LINE1,
	ECG_PROGRAMMER14LINE2,
	ECG_PROGRAMMER11LINE1,
	ECG_PROGRAMMER11LINE2,
	ECG_PROGRAMMER12LINE1,
	ECG_PROGRAMMER12LINE2,
	ECG_PROGRAMMER13LINE1,
	ECG_PROGRAMMER13LINE2,
	ECG_SCREEN28_END,

	ECG_SCREEN29_START,
	ECG_SOUNDDEPT,
	ECG_SOUNDNAME1,
	ECG_SOUNDTITLE1_1,
	ECG_SOUNDTITLE1_2,
	ECG_SOUNDNAME2,
	ECG_SOUNDTITLE2_1,
	ECG_SOUNDTITLE2_2,
	ECG_SOUNDNAME3,
	ECG_SOUNDTITLE3_1,
	ECG_SOUNDTITLE3_2,
	ECG_SCREEN29_END,

	ECG_SCREEN29_5_START,
	ECG_SUPPORTDEPT,
	ECG_SUPPORTNAME1,
	ECG_SUPPORTTITLE1,
	ECG_SUPPORTNAME2,
	ECG_SUPPORTTITLE2_1,
	ECG_SUPPORTTITLE2_2,
	ECG_SCREEN29_5_END,

	ECG_SCREEN30_START,
	ECG_PRODUCTIONDEPT2,

	ECG_PRODUCTIONDEPT,
	ECG_PRODUCERNAME1,
	ECG_PRODUCTIONNAME2,
	ECG_PRODUCTIONTITLE2,
	ECG_PRODUCTIONNAME3,
	ECG_PRODUCTIONTITLE3,
	ECG_PRODUCTIONNAME4,
	ECG_PRODUCTIONTITLE4,
	ECG_CUSTOMERSUPPORTDEPT,
	ECG_CUSTOMERSUPPORTNAME1,
	ECG_CUSTOMERSUPPORTTITLE1,
	ECG_CUSTOMERSUPPORTNAME2,
	ECG_CUSTOMERSUPPORTTITLE2,
	ECG_CUSTOMERSUPPORTNAME3,
	ECG_CUSTOMERSUPPORTTITLE3,
	ECG_CUSTOMERSUPPORTNAME4,
	ECG_CUSTOMERSUPPORTTITLE4,
	ECG_SCREEN30_END,

	ECG_SCREEN31_START,
	ECG_USMARKETINGDEPT,
	ECG_USMARKETINGNAME1,
	ECG_USMARKETINGTITLE1,
	ECG_USMARKETINGNAME2,
	ECG_USMARKETINGTITLE2,
	ECG_USMARKETINGNAME3,
	ECG_USMARKETINGTITLE3_1,
	ECG_USMARKETINGTITLE3_2,
	ECG_USMARKETINGNAME4,
	ECG_USMARKETINGTITLE4_1,
	ECG_USMARKETINGTITLE4_2,
	ECG_USMARKETINGNAME5,
	ECG_USMARKETINGTITLE5_1,
	ECG_USMARKETINGTITLE5_2,

	ECG_PUBLICRELATIONSDEPT,
	ECG_PUBLICRELATIONSNAME1,
	ECG_PUBLICRELATIONSTITLE1,
	ECG_PUBLICRELATIONSNAME2,
	ECG_PUBLICRELATIONSTITLE2_1,
	ECG_PUBLICRELATIONSTITLE2_2,
	ECG_SCREEN31_END,

	ECG_SCREEN32_START,
	ECG_INTERNATIONALDEPT,
	ECG_INTERNATIONALNAME1,
	ECG_INTERNATIONALTITLE1_1,
	ECG_INTERNATIONALNAME2,
	ECG_INTERNATIONALTITLE2_1,
	ECG_INTERNATIONALNAME3,
	ECG_INTERNATIONALTITLE3,
	ECG_INTERNATIONALNAME4,
	ECG_INTERNATIONALTITLE4,
	ECG_INTERNATIONALNAME5,
	ECG_INTERNATIONALTITLE5_1,
	ECG_INTERNATIONALNAME6,
	ECG_INTERNATIONALTITLE6,
	ECG_INTERNATIONALNAME7,
	ECG_INTERNATIONALTITLE7,

	ECG_FRANCEMARKETINGNAME1,
	ECG_FRANCEMARKETINGTITLE1,
	ECG_FRANCEMARKETINGNAME2,
	ECG_FRANCEMARKETINGTITLE2,
	ECG_FRANCEMARKETINGNAME3,
	ECG_FRANCEMARKETINGTITLE3,
	ECG_INTERNATIONALNAME8,
	ECG_INTERNATIONALTITLE8,
	ECG_INTERNATIONALNAME9,
	ECG_INTERNATIONALTITLE9,
	ECG_SCREEN32_END,

	ECG_SCREEN33_START,
	ECG_LOCALIZATIONDEPT,
	ECG_LOCALIZATIONNAME1,
	ECG_LOCALIZATIONTITLE1_1,
	ECG_LOCALIZATIONTITLE1_2,
	ECG_LOCALIZATIONNAME2,
	ECG_LOCALIZATIONTITLE2,
	ECG_LOCALIZATIONNAME3,
	ECG_LOCALIZATIONTITLE3,
	ECG_LOCALIZATIONNAME4,
	ECG_LOCALIZATIONTITLE4,
	ECG_SCREEN33_END,

	ECG_SCREEN33_5_START,
	ECG_QADEPT,
	ECG_QANAME1,
	ECG_QATITLE1,
	ECG_QANAME2,
	ECG_QATITLE2,
	ECG_QANAME3,
	ECG_QATITLE3,
	ECG_QANAME4,
	ECG_QATITLE4,
	ECG_QANAME5,
	ECG_QATITLE5,
	ECG_QANAME6,
	ECG_QATITLE6,
	ECG_QANAME7,
	ECG_QATITLE7,
	ECG_QANAME8,
	ECG_QATITLE8,
	ECG_SCREEN33_5_END,

	ECG_SCREEN33_8_START,
	ECG_QADEPT2,
	ECG_QANAME9,
	ECG_QANAME10,
	ECG_QANAME11,
	ECG_QANAME12,
	ECG_QANAME13,
	ECG_QANAME14,
	ECG_QANAME15,
	ECG_QANAME16,
	ECG_QANAME17,
	ECG_QANAME18,
	ECG_QANAME19,
	ECG_QANAME20,
	ECG_QANAME21,
	ECG_QANAME22,
	ECG_QANAME23,
	ECG_QANAME24,
	ECG_QANAME25,
	ECG_QANAME26,
	ECG_SCREEN33_8_END,

	ECG_SCREEN33_9_START,
	ECG_CODERELEASEDEPT,
	ECG_CODERELEASENAME1,
	ECG_CODERELEASETITLE1,
	ECG_CODERELEASENAME2,
	ECG_CODERELEASETITLE2,
	ECG_COMPATABILITYDEPT,
	ECG_COMPATABILITYNAME1,
	ECG_COMPATABILITYNAME2,
	ECG_NETWORKLABDEPT,
	ECG_NETWORKLABNAME1,
	ECG_INSTALLERDEPT,
	ECG_INSTALLERNAME1,
	ECG_INSTALLERNAME2,
	ECG_MANUALDEPT,
	ECG_MANUALNAME1,
	ECG_MANUALTITLE1,
	ECG_SCREEN33_9_END,

	ECG_SCREEN34_START,
	ECG_MISDEPT,
	ECG_MISNAME1,
	ECG_MISNAME2,
	ECG_MISNAME3,
	ECG_MISNAME4,
	ECG_MISNAME5,
	ECG_MISNAME6,
	ECG_MISNAME7,
	ECG_MISNAME8,
	ECG_MISNAME9,
	ECG_MISNAME10,
	ECG_MISNAME11,

	ECG_SCREEN34_END,


	ECG_SCREEN35_START,
	ECG_VIACOMPARAMOUNTLIASONS,
	ECG_LIASONSNAME1,
	ECG_LIASONSTITLE1_1,
	ECG_LIASONSTITLE1_2,
	ECG_LIASONSNAME2,
	ECG_LIASONSTITLE2_1,
	ECG_LIASONSTITLE2_2,
	ECG_SCREEN35_END,

	ECG_SCREEN35_5_START,
	ECG_VIACOM,
	ECG_VIACOMDEPT,
	ECG_VIACOMNAME1,
	ECG_VIACOMNAME2,
	ECG_VIACOMNAME3,
	ECG_VIACOMNAME4,
	ECG_VIACOMNAME5,
	ECG_VIACOMNAME6,
	ECG_VIACOMNAME7,
	ECG_CONSULTANT,
	ECG_CONSULTANTNAME1,
	ECG_CONSULTANTTITLE1_1,
	ECG_CONSULTANTTITLE1_2,
	ECG_SCREEN35_5_END,

	ECG_SCREEN36_START,
	ECG_COMPUTERRENDEREDANIMATION,
	ECG_CREATDEPT,
	ECG_CREATNAME1,
	ECG_CREATTITLE1,
	ECG_CREATNAME2,
	ECG_CREATTITLE2,
	ECG_CREATNAME3,
	ECG_CREATTITLE3,
	ECG_CREATNAME4,
	ECG_CREATTITLE4,
	ECG_CREATNAME5,
	ECG_CREATTITLE5,
	ECG_CREATNAME6,
	ECG_CREATTITLE6,
	ECG_CREATNAME7,
	ECG_CREATTITLE7,
	ECG_CREATNAME8,
	ECG_CREATTITLE8,
	ECG_CREATNAME9,
	ECG_CREATTITLE9,
	ECG_CREATNAME10,
	ECG_CREATTITLE10,
	ECG_CREATNAME11,
	ECG_CREATTITLE11,

	ECG_OPENINGCREDITSDEPT,
	ECG_OPENINGCREDITS_NAME,
	ECG_OPENINGCREDITS_TITLE1,
	ECG_OPENINGCREDITS_TITLE2,

	ECG_LOGOSEQUENCEDEPT,
	ECG_LOGOSEQUENCE_NAME,
	ECG_SCREEN36_END,

	ECG_SCREEN37_START,
	ECG_VOCALTALENTS,
	ECG_DIRECTORDEPT,
	ECG_DIRECTORNAME1,
	ECG_CASTINGDEPT,
	ECG_CASTINGNAME1,
	ECG_CASTINGTITLE1,
	ECG_CASTINGNAME2,
	ECG_CASTINGTITLE2,
	ECG_CASTINGNAME3,
	ECG_CASTINGTITLE3,
	ECG_CASTINGNAME4,
	ECG_CASTINGTITLE4,
	ECG_RECORDEDATDEPT,
	ECG_RECORDEDATNAME1,
	ECG_RECORDEDATNAME2,
	ECG_RECORDEDATNAME3,
	ECG_SCREEN37_END,

	ECG_SCREEN37_1_START,
	ECG_GERMAN_VOCALTALENTS,
	ECG_GERMAN_CASTINGDEPT,
	ECG_GERMAN_CASTINGNAME1,
	ECG_GERMAN_CASTINGTITLE1,
	ECG_GERMAN_CASTINGNAME2,
	ECG_GERMAN_CASTINGTITLE2,
	ECG_GERMAN_CASTINGNAME3,
	ECG_GERMAN_RECORDEDATDEPT,
	ECG_GERMAN_RECORDEDATNAME1,
	ECG_GERMAN_DIRECTORDEPT,
	ECG_GERMAN_DIRECTORNAME1,
	ECG_SCREEN37_1_END,

	ECG_SCREEN38_START,
	ECG_CREATIVESERVICES,
	ECG_IGNITEDMINDS,
	ECG_IGNITEDMINDS_NAME1,
	ECG_IGNITEDMINDS_TITLE1,
	ECG_IGNITEDMINDS_NAME2,
	ECG_IGNITEDMINDS_TITLE2,
	ECG_IGNITEDMINDS_NAME3,
	ECG_IGNITEDMINDS_TITLE3,
	ECG_SCREEN38_END,

	ECG_SCREEN38_5_START,
	ECG_SPECIALTHANKS,
	ECG_ACTIVISIONDEPT,
	ECG_ACTIVISIONNAME1,
	ECG_ACTIVISIONNAME2,
	ECG_ACTIVISIONNAME3,
	ECG_ACTIVISIONNAME4,
	ECG_ACTIVISIONNAME5,
	ECG_ACTIVISIONNAME6,
	ECG_ACTIVISIONNAME7,
	ECG_ACTIVISIONNAME8,
	ECG_ACTIVISIONNAME9,
	ECG_ACTIVISIONNAME10,
	ECG_ACTIVISIONNAME11,
	ECG_ACTIVISIONNAME12,
	ECG_ACTIVISIONNAME13,
	ECG_ACTIVISIONNAME14,
	ECG_SCREEN38_5_END,

	ECG_SCREEN39_START,
	ECG_VERYSPECIALTHANKSDEPT,
	ECG_VERSPECIALTNAME1,
	ECG_SCREEN39_END,

	ECG_SCREEN40_START,
	ECG_XSPECIALTHANKSDEPT,
	ECG_XSPECIALTNAME1,
	ECG_XSPECIALTTITLE1,
	ECG_XSPECIALTNAME2,
	ECG_XSPECIALTTITLE2,
	ECG_XSPECIALTNAME3,
	ECG_XSPECIALTTITLE3,
	ECG_XSPECIALTNAME4,
	ECG_XSPECIALTTITLE4,

	ECG_XSPECIALTTITLE15,
	ECG_XSPECIALTNAME13,
	ECG_XSPECIALTTITLE13,
	ECG_XSPECIALTNAME14,
	ECG_XSPECIALTTITLE14,
	ECG_XSPECIALTTITLE16,
	ECG_XSPECIALTTITLE17,
	ECG_XSPECIALTTITLE18,

	ECG_XSPECIALTNAME5,
	ECG_XSPECIALTTITLE5,
	ECG_XSPECIALTNAME6,
	ECG_XSPECIALTTITLE6,
	ECG_XSPECIALTNAME7,
	ECG_XSPECIALTTITLE7,
	ECG_XSPECIALTNAME8,
	ECG_XSPECIALTTITLE8,
	ECG_XSPECIALTNAME9,
	ECG_XSPECIALTTITLE9,
	ECG_XSPECIALTNAME10,
	ECG_XSPECIALTTITLE10,
	ECG_XSPECIALTNAME11,
	ECG_XSPECIALTTITLE11,
	ECG_XSPECIALTNAME19,
	ECG_XSPECIALTTITLE19,
	ECG_XSPECIALTNAME20,
	ECG_XSPECIALTTITLE20,
	ECG_XSPECIALTNAME21,
	ECG_XSPECIALTTITLE21,
	ECG_SCREEN40_END,

	ECG_SCREEN41_START,
	ECG_ANDTHANKSTO,
	ECG_XSPECIALTNAME12,
	ECG_XSPECIALTTITLE12_1,
	ECG_XSPECIALTTITLE12_2,
	ECG_SCREEN41_END,

	ECG_SCREEN_PIC_START,
	ECG_SCREEN1_PIC,
	ECG_SCREEN2_PIC,
	ECG_SCREEN3_PIC,
	ECG_SCREEN4_PIC,
	ECG_SCREEN5_PIC,
	ECG_SCREEN6_PIC,
	ECG_SCREEN7_PIC,
	ECG_SCREEN8_PIC,
	ECG_SCREEN9_PIC,
	ECG_SCREEN10_PIC,
	ECG_SCREEN11_PIC,
	ECG_SCREEN12_PIC,
	ECG_SCREEN13_PIC,
	ECG_SCREEN14_PIC,
	ECG_SCREEN15_PIC,
	ECG_SCREEN16_PIC,
	ECG_SCREEN17_PIC,
	ECG_SCREEN_PIC_END,

	ECG_MAX
} endcreditsmenu_graphics_t;


//#define ACTOR_LINE1_Y	210
//#define ACTOR_LINE2_Y	240
//#define ACTOR_LINE3_Y	270

#define ACTOR_LINE1_Y	194
#define ACTOR_LINE2_Y	224
#define ACTOR_LINE3_Y	254

#define ACTOR_Y_PAD		30
#define ACTOR_X1		40
#define ACTOR_X2		310
#define ACTOR_SCREEN_Y	 80


#define ACTOR_PIC_X		480
#define ACTOR_PIC_Y		184
#define X_MID			320

menugraphics_s endcreditsmenu_graphics[ECG_MAX] = 
{
//	type		timer	x		y		width	height	file/text													graphic,	min		max		target				inc		style			color	
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN16_PIC,	0,		NULL,		0,		0,		ECG_SCREEN1_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN1
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN2_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN2
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN1_PIC,	0,		NULL,		0,		0,		ECG_SCREEN3_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN3
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN2_PIC,	0,		NULL,		0,		0,		ECG_SCREEN4_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN4
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN3_PIC,	0,		NULL,		0,		0,		ECG_SCREEN5_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN5
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN4_PIC,	0,		NULL,		0,		0,		ECG_SCREEN6_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN6
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN5_PIC,	0,		NULL,		0,		0,		ECG_SCREEN7_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN7
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN6_PIC,	0,		NULL,		0,		0,		ECG_SCREEN8_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN8
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN7_PIC,	0,		NULL,		0,		0,		ECG_SCREEN9_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN9
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN8_PIC,	0,		NULL,		0,		0,		ECG_SCREEN10_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN10
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN17_PIC,	0,		NULL,		0,		0,		ECG_SCREEN10_0_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN10_0
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN9_PIC,	0,		NULL,		0,		0,		ECG_SCREEN11_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN11
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN10_PIC,	0,		NULL,		0,		0,		ECG_SCREEN12_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN12
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN11_PIC,	0,		NULL,		0,		0,		ECG_SCREEN13_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN13
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN12_PIC,	0,		NULL,		0,		0,		ECG_SCREEN14_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN14
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN13_PIC,	0,		NULL,		0,		0,		ECG_SCREEN15_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN15
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN14_PIC,	0,		NULL,		0,		0,		ECG_SCREEN16_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN16
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN15_PIC,	0,		NULL,		0,		0,		ECG_SCREEN17_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN17
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN18_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN18
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN19_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19

	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN37_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN37

	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN19_0_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_0
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN1_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_1_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_1
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN2_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_2_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_2
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN3_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_3_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_3
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN4_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_4_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_4
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN5_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_5_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_5
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN6_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_6_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_6
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN7_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_7_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_7
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN8_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_8_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_8
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN17_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_15_5_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_10

	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN9_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_9_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_9
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN10_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_10_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_11
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN11_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_11_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_12
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN12_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_12_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_13
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN13_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_13_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_14
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN14_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_14_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_15
	MG_VAR,		6000.0,	0,		0,		0,		0,		NULL,							ECG_SCREEN15_PIC,	0,		NULL,		0,		0,		ECG_SCREEN19_15_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_15_5
	MG_VAR,		10000.0,0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN19_16_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_16
	MG_VAR,		10000.0,0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN19_17_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN19_17

	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN37_1_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN37_1

	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN20_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN20
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN21_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN21
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN22_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN22
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN23_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN23
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN24_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN24
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN25_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN25
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN26_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN26
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN27_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN27
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN28_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN28
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN29_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN29
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN29_5_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN29_5
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN30_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN30
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN31_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN31
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN32_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN32
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN33_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN33
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN33_5_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN33_5
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN33_8_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN33_8
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN33_9_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN33_9
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN34_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN34
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN35_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN35
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN35_5_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN35_5
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN36_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN36
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN38_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN38
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN38_5_START,0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN38_5
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN39_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN39
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN40_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN40
	MG_VAR,		10000.0,	0,		0,		0,		0,		NULL,							0,					0,		NULL,		0,		0,		ECG_SCREEN41_START,	0,		0,				CT_NONE,		NULL,	// 	ECG_SCREEN41

	MG_FADE,	0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,		0,				CT_NONE,		NULL,	// 	ECG_FADE
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,		0,				CT_NONE,		NULL,	// 	ECG_FADEFLAG

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,					0,	NULL,0,	0,		0,					0,		0,						CT_NONE,		NULL,	// 	ECG_SCREEN1_START
	MG_STRING,	0.0,	320,	260,	0,		0,		NULL,							MNT_ISA,			0,	NULL,0,	0,		0,					0,		UI_CENTER|UI_BIGFONT,	CT_DKGOLD1,		NULL,	//	ECG_OPENING1LINE1
	MG_STRING,	0.0,	320,	300,	0,		0,		NULL,							MNT_RAVENSACTIVISION,0,	NULL,0,	0,		0,					0,		UI_CENTER|UI_BIGFONT,	CT_YELLOW,		NULL,	//	ECG_OPENING1LINE2
	MG_STRING,	0.0,	320,	340,	0,		0,		NULL,							MNT_PRODUCTION,0,		NULL,0,	0,		0,					0,		UI_CENTER|UI_BIGFONT,	CT_DKGOLD1,		NULL,	//	ECG_OPENING1LINE3
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,		0,						CT_NONE,		NULL,	// 	ECG_SCREEN1_END

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN2_START
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,0,	NULL,							MNT_FEATURING,0,NULL,	0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_LTPURPLE1,	NULL,	//	ECG_OPENING2LINE1
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN2_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN3_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_VOYAGERCASTNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR1LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR1LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR1LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN3_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN4_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_VOYAGERCASTNAME2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR2LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR2LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR2LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN4_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN5_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_VOYAGERCASTNAME3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR3LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR3LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR3LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN5_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN6_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_VOYAGERCASTNAME4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR4LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR4LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR4LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN6_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN7_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_VOYAGERCASTNAME5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR5LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR5LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR5LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN7_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN8_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_VOYAGERCASTNAME6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR6LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR6LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR6LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN8_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN9_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,		 			MNT_VOYAGERCASTNAME7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR7LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR7LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR7LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN9_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN10_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,		 			MNT_VOYAGERCASTNAME8,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR8LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE8,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN10_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN10_0_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,		 			MNT_VOYAGERCASTNAME9,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR8LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_VOYAGERCASTTITLE9,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN10_0_END


	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN11_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR9LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR9LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR9LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN11_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN12_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME2,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR10LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR10LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR10LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN12_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN13_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME3,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR11LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR11LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR11LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN13_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN14_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME4,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR12LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR12LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR12LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN14_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN15_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME5,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR13LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR13LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR13LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN15_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN16_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME6,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR14LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR14LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR14LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN16_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN17_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_ELITECASTNAME7,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR15LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,					0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_ELITECASTTITLE7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN17_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN18_START
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y,					0,		0,		NULL,	MNT_ELITECASTNAME8,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR16LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y,					0,		0,		NULL,	MNT_ELITECASTTITLE8,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR16LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+ACTOR_Y_PAD,		0,		0,		NULL,	MNT_ELITECASTNAME9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR15LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+ACTOR_Y_PAD,		0,		0,		NULL,	MNT_ELITECASTTITLE9,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_ELITECASTNAME10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR17LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_ELITECASTTITLE10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR17LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_ELITECASTNAME11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR18LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_ELITECASTTITLE11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR18LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_ELITECASTNAME12,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR19LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_ELITECASTTITLE12,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR19LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_ELITECASTNAME13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR20LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_ELITECASTTITLE13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR20LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_ELITECASTNAME14,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR21LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_ELITECASTTITLE14,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR21LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_ELITECASTNAME15,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR22LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_ELITECASTTITLE15,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR22LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_ELITECASTNAME16,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR23LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_ELITECASTTITLE16,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR23LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_ELITECASTNAME17,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR24LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_ELITECASTTITLE17,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR24LINE1_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN18_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_START
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*0),	0,		0,		NULL,	MNT_ELITECASTNAME18,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR25LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*0),	0,		0,		NULL,	MNT_ELITECASTTITLE18,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR25LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*1),	0,		0,		NULL,	MNT_ELITECASTNAME19,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR26LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*1),	0,		0,		NULL,	MNT_ELITECASTTITLE19,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR26LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_ELITECASTNAME20,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR27LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_ELITECASTTITLE20,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR27LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_ELITECASTNAME21,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR28LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_ELITECASTTITLE21,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR28LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_ELITECASTNAME22,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR29LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_ELITECASTTITLE22,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR29LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_ELITECASTNAME23,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR30LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_ELITECASTTITLE23,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR30LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_ELITECASTNAME24,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR31LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_ELITECASTTITLE24,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR31LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_ELITECASTNAME25,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR32LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_ELITECASTTITLE25,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR32LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_ELITECASTNAME26,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR33LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_ELITECASTTITLE26,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR33LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_ELITECASTNAME27,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR34LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_ELITECASTTITLE27,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR34LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*10),0,		0,		NULL,	MNT_ELITECASTNAME28,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR35LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*10),0,		0,		NULL,	MNT_ELITECASTTITLE28,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR35LINE1_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_0_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_GERMANACTORS1,				0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR1LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_GERMANACTORS2,				0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR1LINE2
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_0_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_1_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR1LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR1LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR1LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_1_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_2_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTNAME2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR2LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR2LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR2LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_2_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_3_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTNAME3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR3LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR3LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR3LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_3_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_4_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_GERMAN_VOYAGERCASTNAME4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR4LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR4LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR4LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_4_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_5_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_GERMAN_VOYAGERCASTNAME5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR5LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR5LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR5LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_5_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_6_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL, 					MNT_GERMAN_VOYAGERCASTNAME6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR6LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR6LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR6LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_6_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_7_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,		 			MNT_GERMAN_VOYAGERCASTNAME7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR7LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR7LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR7LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_7_END

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_8_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,		NULL,		 			MNT_GERMAN_VOYAGERCASTNAME8,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR8LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,		NULL,					MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,		NULL,					MNT_GERMAN_VOYAGERCASTTITLE8,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR8LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,					0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_8_END



	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_9_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR9LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR9LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR9LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_9_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_10_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME2,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR10LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR10LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE2,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR10LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_10_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_11_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME3,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR11LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR11LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE3,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR11LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_11_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_12_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME4,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR12LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR12LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE4,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR12LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_12_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_13_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME5,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR13LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR13LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE5,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR13LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_13_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_14_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME6,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR14LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR14LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE6,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR14LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_14_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_15_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME7,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR15LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE7,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_15_END

	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_15_5_START
	MG_OFF,		0.0,	320,	ACTOR_LINE1_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTNAME20,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_WHITE,		NULL,	//	ECG_ACTOR15LINE1
	MG_OFF,		0.0,	320,	ACTOR_LINE2_Y,	0,		0,	NULL,	MNT_AS,							0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE2
	MG_OFF,		0.0,	320,	ACTOR_LINE3_Y,	0,		0,	NULL,	MNT_GERMAN_ELITECASTTITLE20,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,	CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE3
	MG_VAR,		0.0,	0,		0,				0,		0,	NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN19_15_5_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_16_START
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y,					0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME8,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR16LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y,					0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE8,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR16LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+ACTOR_Y_PAD,		0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR15LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+ACTOR_Y_PAD,		0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR15LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME10,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR17LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR17LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME11,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR18LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR18LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME12,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR19LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE12,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR19LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME13,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR20LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR20LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME14,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR21LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE14,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR21LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME15,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR22LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE15,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR22LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME16,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR23LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE16,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR23LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME17,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR24LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE17,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR24LINE1_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_16_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_17_START
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*0),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME18,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR25LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*0),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE18,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR25LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*1),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME19,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR26LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*1),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE19,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR26LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME21,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR28LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*2),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE21,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR28LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME22,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR29LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*3),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE22,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR29LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME23,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR30LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*4),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE23,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR30LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME24,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR31LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*5),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE24,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR31LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME25,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR32LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*6),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE25,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR32LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME26,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR33LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*7),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE26,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR33LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME27,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR34LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*8),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE27,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR34LINE1_2
	MG_OFF,		0.0,	ACTOR_X1,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_GERMAN_ELITECASTNAME28,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTOR35LINE1_1
	MG_OFF,		0.0,	ACTOR_X2,	ACTOR_SCREEN_Y+(ACTOR_Y_PAD*9),	0,		0,		NULL,	MNT_GERMAN_ELITECASTTITLE28,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_ACTOR35LINE1_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,								0,		NULL,		0,		0,		0,					0,			0,					CT_NONE,		NULL,	// 	ECG_SCREEN19_17_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN20_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_RAVENSOFTWARE,	 	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_LEADTITLE
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_LEADNAME1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD1LINE1
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_LEADTITLE1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD1LINE2
	MG_OFF,		0.0,	ACTOR_X1,	240,							0,		0,		NULL,	MNT_LEADNAME2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD2LINE1
	MG_OFF,		0.0,	ACTOR_X2,	240,							0,		0,		NULL,	MNT_LEADTITLE2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD2LINE1
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN20_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN21_START
	MG_OFF,		0.0,	ACTOR_X1,	200,							0,		0,		NULL,	MNT_LEADNAME3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD3LINE1
	MG_OFF,		0.0,	ACTOR_X2,	200,							0,		0,		NULL,	MNT_LEADTITLE3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD3LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN21_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN22_START
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_LEADNAME4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD4LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_LEADTITLE4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD4LINE2
	MG_OFF,		0.0,	ACTOR_X1,	172,							0,		0,		NULL,	MNT_LEADNAME5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD5LINE1
	MG_OFF,		0.0,	ACTOR_X2,	172,							0,		0,		NULL,	MNT_LEADTITLE5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD5LINE2
	MG_OFF,		0.0,	ACTOR_X1,	244,							0,		0,		NULL,	MNT_LEADNAME6,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD6LINE1
	MG_OFF,		0.0,	ACTOR_X2,	244,							0,		0,		NULL,	MNT_LEADTITLE6,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD6LINE2
	MG_OFF,		0.0,	ACTOR_X1,	316,							0,		0,		NULL,	MNT_LEADNAME7,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_LEAD7LINE1
	MG_OFF,		0.0,	ACTOR_X2,	316,							0,		0,		NULL,	MNT_LEADTITLE7,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_LEAD7LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN22_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN23_START
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_ARTNAME1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST1LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_ARTTITLE1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST1LINE2
	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_ARTNAME2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST2LINE1
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_ARTTITLE2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST2LINE2
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_ARTNAME3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST3LINE1
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_ARTTITLE3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST3LINE2
	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_ARTNAME4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST4LINE1
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_ARTTITLE4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST4LINE2
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_ARTNAME5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST5LINE1
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_ARTTITLE5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST5LINE2
	MG_OFF,		0.0,	ACTOR_X1,	250,							0,		0,		NULL,	MNT_ARTNAME6,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST6LINE1
	MG_OFF,		0.0,	ACTOR_X2,	250,							0,		0,		NULL,	MNT_ARTTITLE6,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST6LINE2
	MG_OFF,		0.0,	ACTOR_X1,	280,							0,		0,		NULL,	MNT_ARTNAME7,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST7LINE1
	MG_OFF,		0.0,	ACTOR_X2,	280,							0,		0,		NULL,	MNT_ARTTITLE7,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST7LINE2
	MG_OFF,		0.0,	ACTOR_X1,	310,							0,		0,		NULL,	MNT_ARTNAME8,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST8LINE1
	MG_OFF,		0.0,	ACTOR_X2,	310,							0,		0,		NULL,	MNT_ARTTITLE8,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST8LINE2
	MG_OFF,		0.0,	ACTOR_X1,	340,							0,		0,		NULL,	MNT_ARTNAME10,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST9LINE1
	MG_OFF,		0.0,	ACTOR_X2,	340,							0,		0,		NULL,	MNT_ARTTITLE10,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST9LINE2
	MG_OFF,		0.0,	ACTOR_X1,	370,							0,		0,		NULL,	MNT_ARTNAME9,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_ARTIST10LINE1
	MG_OFF,		0.0,	ACTOR_X2,	370,							0,		0,		NULL,	MNT_ARTTITLE9,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_ARTIST10LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN23_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN24_START
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_ANIMNAME1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_MODELER1LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_ANIMTITLE1,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_MODELER1LINE2
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_ANIMNAME2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_MODELER2LINE1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_ANIMTITLE2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_MODELER2LINE2
	MG_OFF,		0.0,	ACTOR_X1,	180,							0,		0,		NULL,	MNT_ANIMNAME3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_MODELER3LINE1
	MG_OFF,		0.0,	ACTOR_X2,	180,							0,		0,		NULL,	MNT_ANIMTITLE3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_MODELER3LINE2
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_ANIMNAME4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_MODELER4LINE1
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_ANIMTITLE4,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_MODELER4LINE2
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_ANIMNAME5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_MODELER5LINE1
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_ANIMTITLE5,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_MODELER5LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN24_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN25_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_DESIGNERDEPT,	 	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_DESIGNERDEPT1
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_DESIGNERNAME1,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER1LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_DESIGNERTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER1LINE2
	MG_OFF,		0.0,	ACTOR_X1,	135,							0,		0,		NULL,	MNT_DESIGNERNAME2,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER2LINE1
	MG_OFF,		0.0,	ACTOR_X2,	135,							0,		0,		NULL,	MNT_DESIGNERTITLE2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER2LINE2
	MG_OFF,		0.0,	ACTOR_X1,	170,							0,		0,		NULL,	MNT_DESIGNERNAME3,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER3LINE1
	MG_OFF,		0.0,	ACTOR_X2,	170,							0,		0,		NULL,	MNT_DESIGNERTITLE3,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER3LINE2
	MG_OFF,		0.0,	ACTOR_X1,	205,							0,		0,		NULL,	MNT_DESIGNERNAME4,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER4LINE1
	MG_OFF,		0.0,	ACTOR_X2,	205,							0,		0,		NULL,	MNT_DESIGNERTITLE4,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER4LINE2
	MG_OFF,		0.0,	ACTOR_X1,	240,							0,		0,		NULL,	MNT_DESIGNERNAME5,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER5LINE1
	MG_OFF,		0.0,	ACTOR_X2,	240,							0,		0,		NULL,	MNT_DESIGNERTITLE5,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER5LINE2
	MG_OFF,		0.0,	ACTOR_X1,	275,							0,		0,		NULL,	MNT_DESIGNERNAME6,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER6LINE1
	MG_OFF,		0.0,	ACTOR_X2,	275,							0,		0,		NULL,	MNT_DESIGNERTITLE6,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER6LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN25_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN26_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_DESIGNERDEPT,	 	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_DESIGNERDEPT2
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_DESIGNERNAME7,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER7LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_DESIGNERTITLE7,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER7LINE2
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_DESIGNERNAME8,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER8LINE1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_DESIGNERTITLE8,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER8LINE2
	MG_OFF,		0.0,	ACTOR_X1,	180,							0,		0,		NULL,	MNT_DESIGNERNAME9,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER9LINE1
	MG_OFF,		0.0,	ACTOR_X2,	180,							0,		0,		NULL,	MNT_DESIGNERTITLE9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER9LINE2
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_DESIGNERNAME10,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER10LINE1
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_DESIGNERTITLE10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER10LINE2
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_DESIGNERNAME11,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_DESIGNER11LINE1
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_DESIGNERTITLE11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_DESIGNER11LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN26_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN27_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_PROGRAMMINGDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_PROGRAMMERDEPT
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_PROGRAMMERNAME1, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER1LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_PROGRAMMERTITLE1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER1LINE2
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_PROGRAMMERNAME3, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER2LINE1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_PROGRAMMERTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER2LINE2
	MG_OFF,		0.0,	ACTOR_X1,	180,							0,		0,		NULL,	MNT_PROGRAMMERNAME2, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER3LINE1
	MG_OFF,		0.0,	ACTOR_X2,	180,							0,		0,		NULL,	MNT_PROGRAMMERTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER3LINE2
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_PROGRAMMERNAME4, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER4LINE1
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_PROGRAMMERTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER4LINE2
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_PROGRAMMERNAME5, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER5LINE1
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_PROGRAMMERTITLE5,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER5LINE2
	MG_OFF,		0.0,	ACTOR_X1,	300,							0,		0,		NULL,	MNT_PROGRAMMERNAME6, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER6LINE1
	MG_OFF,		0.0,	ACTOR_X2,	300,							0,		0,		NULL,	MNT_PROGRAMMERTITLE6,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER6LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN27_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN28_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_PROGRAMMINGDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_PROGRAMMERDEPT
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_PROGRAMMERNAME7, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER7LINE1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_PROGRAMMERTITLE7,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER7LINE2
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_PROGRAMMERNAME8, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER8LINE1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_PROGRAMMERTITLE8,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER8LINE2
	MG_OFF,		0.0,	ACTOR_X1,	180,							0,		0,		NULL,	MNT_PROGRAMMERNAME9, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER9LINE1
	MG_OFF,		0.0,	ACTOR_X2,	180,							0,		0,		NULL,	MNT_PROGRAMMERTITLE9,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER9LINE2
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_PROGRAMMERNAME10, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER10LINE1
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_PROGRAMMERTITLE10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER10LINE2
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_PROGRAMMERNAME11, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER11LINE1
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_PROGRAMMERTITLE11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER11LINE2
	MG_OFF,		0.0,	ACTOR_X1,	300,							0,		0,		NULL,	MNT_PROGRAMMERNAME12, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER12LINE1
	MG_OFF,		0.0,	ACTOR_X2,	300,							0,		0,		NULL,	MNT_PROGRAMMERTITLE12,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER12LINE2
	MG_OFF,		0.0,	ACTOR_X1,	340,							0,		0,		NULL,	MNT_PROGRAMMERNAME13, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER13LINE1
	MG_OFF,		0.0,	ACTOR_X2,	340,							0,		0,		NULL,	MNT_PROGRAMMERTITLE13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER13LINE2
	MG_OFF,		0.0,	ACTOR_X1,	380,							0,		0,		NULL,	MNT_PROGRAMMERNAME14, 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_PROGRAMMER14LINE1
	MG_OFF,		0.0,	ACTOR_X2,	380,							0,		0,		NULL,	MNT_PROGRAMMERTITLE14,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_PROGRAMMER14LINE2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN28_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN29_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_SOUNDDEPT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_SOUNDDEPT
	MG_OFF,		0.0,	ACTOR_X1,	120,							0,		0,		NULL,	MNT_SOUNDNAME1,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_SOUNDNAME1
	MG_OFF,		0.0,	ACTOR_X2,	120,							0,		0,		NULL,	MNT_SOUNDTITLE1_1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE1_1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_SOUNDTITLE1_2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE1_2

	MG_OFF,		0.0,	ACTOR_X1,		190,							0,		0,		NULL,	MNT_SOUNDNAME2,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_SOUNDNAME2
	MG_OFF,		0.0,	ACTOR_X2,		190,							0,		0,		NULL,	MNT_SOUNDTITLE2_1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE2_1
	MG_OFF,		0.0,	ACTOR_X2,		210,							0,		0,		NULL,	MNT_SOUNDTITLE2_2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE2_2

	MG_OFF,		0.0,	ACTOR_X1,		260,							0,		0,		NULL,	MNT_SOUNDNAME3,		 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_SOUNDNAME3
	MG_OFF,		0.0,	ACTOR_X2,		260,							0,		0,		NULL,	MNT_SOUNDTITLE3_1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE3_1
	MG_OFF,		0.0,	ACTOR_X2,		280,							0,		0,		NULL,	MNT_SOUNDTITLE3_2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SOUNDTITLE3_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN29_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN29_5_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_SUPPORTDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_SUPPORTDEPT

	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_SUPPORTNAME1,	 	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_SUPPORTNAME1
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_SUPPORTTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SUPPORTTITLE1

	MG_OFF,		0.0,	ACTOR_X1,	230,							0,		0,		NULL,	MNT_SUPPORTNAME2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_SUPPORTNAME2
	MG_OFF,		0.0,	ACTOR_X2,	230,							0,		0,		NULL,	MNT_SUPPORTTITLE2_1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SUPPORTTITLE2_1
	MG_OFF,		0.0,	ACTOR_X2,	250,							0,		0,		NULL,	MNT_SUPPORTTITLE2_2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_SUPPORTTITLE2_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN29_5_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN30_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_PRODUCTIONDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_PRODUCTIONDEPT
	MG_OFF,		0.0,	ACTOR_X1,	80,								0,		0,		NULL,	MNT_PRODUCERNAME1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PRODUCERNAME1
	MG_OFF,		0.0,	ACTOR_X2,	80,								0,		0,		NULL,	MNT_PRODUCERTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PRODUCERTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	120,							0,		0,		NULL,	MNT_PRODUCTIONNAME2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PRODUCTIONNAME2
	MG_OFF,		0.0,	ACTOR_X2,	120,							0,		0,		NULL,	MNT_PRODUCTIONTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PRODUCTIONTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_PRODUCTIONNAME3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PRODUCTIONNAME3
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_PRODUCTIONTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PRODUCTIONTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	200,							0,		0,		NULL,	MNT_PRODUCTIONNAME4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PRODUCTIONNAME4
	MG_OFF,		0.0,	ACTOR_X2,	200,							0,		0,		NULL,	MNT_PRODUCTIONTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PRODUCTIONTITLE4

	MG_OFF,		0.0,	X_MID,		270,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTDEPT,0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CUSTOMERSUPPORTDEPT
	MG_OFF,		0.0,	ACTOR_X1,	310,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTNAME1,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CUSTOMERSUPPORTNAME1
	MG_OFF,		0.0,	ACTOR_X2,	310,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTTITLE1,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CUSTOMERSUPPORTTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	350,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTNAME2,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CUSTOMERSUPPORTNAME2
	MG_OFF,		0.0,	ACTOR_X2,	350,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTTITLE2,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CUSTOMERSUPPORTTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	390,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTNAME3,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CUSTOMERSUPPORTNAME3
	MG_OFF,		0.0,	ACTOR_X2,	390,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTTITLE3,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CUSTOMERSUPPORTTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	430,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTNAME4,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CUSTOMERSUPPORTNAME4
	MG_OFF,		0.0,	ACTOR_X2,	430,							0,		0,		NULL,	MNT_CUSTOMERSUPPORTTITLE3,	0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CUSTOMERSUPPORTTITLE4
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN30_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN31_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_USMARKETINGDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_USMARKETINGDEPT
	MG_OFF,		0.0,	ACTOR_X1,		80,								0,		0,		NULL,	MNT_USMARKETINGNAME1,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_USMARKETINGNAME1
	MG_OFF,		0.0,	ACTOR_X2,		80,								0,		0,		NULL,	MNT_USMARKETINGTITLE1,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE1
	MG_OFF,		0.0,	ACTOR_X1,		110,							0,		0,		NULL,	MNT_USMARKETINGNAME2,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_USMARKETINGNAME2
	MG_OFF,		0.0,	ACTOR_X2,		110,							0,		0,		NULL,	MNT_USMARKETINGTITLE2,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE2
	MG_OFF,		0.0,	ACTOR_X1,		140,							0,		0,		NULL,	MNT_USMARKETINGNAME3,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_USMARKETINGNAME3
	MG_OFF,		0.0,	ACTOR_X2,		140,							0,		0,		NULL,	MNT_USMARKETINGTITLE3_1,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE3_1
	MG_OFF,		0.0,	ACTOR_X2,		160,							0,		0,		NULL,	MNT_USMARKETINGTITLE3_2,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE3_2
	MG_OFF,		0.0,	ACTOR_X1,		200,							0,		0,		NULL,	MNT_USMARKETINGNAME4,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_USMARKETINGNAME4
	MG_OFF,		0.0,	ACTOR_X2,		200,							0,		0,		NULL,	MNT_USMARKETINGTITLE4_1,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE4_1
	MG_OFF,		0.0,	ACTOR_X2,		220,							0,		0,		NULL,	MNT_USMARKETINGTITLE4_2,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE4_2
	MG_OFF,		0.0,	ACTOR_X1,		260,							0,		0,		NULL,	MNT_USMARKETINGNAME5,	0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_USMARKETINGNAME5
	MG_OFF,		0.0,	ACTOR_X2,		260,							0,		0,		NULL,	MNT_USMARKETINGTITLE5_1,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE5_1
	MG_OFF,		0.0,	ACTOR_X2,		280,							0,		0,		NULL,	MNT_USMARKETINGTITLE5_2,0,		NULL,		0,		0,		0,					0,		UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_USMARKETINGTITLE5_2

	MG_OFF,		0.0,	X_MID,			320,							0,		0,		NULL,	MNT_PUBLICRELATIONSDEPT,0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_PUBLICRELATIONSDEPT
	MG_OFF,		0.0,	ACTOR_X1,		360,							0,		0,		NULL,	MNT_PUBLICRELATIONSNAME1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PUBLICRELATIONSNAME1
	MG_OFF,		0.0,	ACTOR_X2,		360,							0,		0,		NULL,	MNT_PUBLICRELATIONSTITLE1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PUBLICRELATIONSTITLE1
	MG_OFF,		0.0,	ACTOR_X1,		400,							0,		0,		NULL,	MNT_PUBLICRELATIONSNAME2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_PUBLICRELATIONSNAME2
	MG_OFF,		0.0,	ACTOR_X2,		400,							0,		0,		NULL,	MNT_PUBLICRELATIONSTITLE2_1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PUBLICRELATIONSTITLE2_1
	MG_OFF,		0.0,	ACTOR_X2,		420,							0,		0,		NULL,	MNT_PUBLICRELATIONSTITLE2_2,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_PUBLICRELATIONSTITLE2_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN31_END

	// Screen 32
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN32_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_INTERNATIONALDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_INTERNATIONALDEPT

	MG_OFF,		0.0,	ACTOR_X1,	70,								0,		0,		NULL,	MNT_INTERNATIONALNAME1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME1
	MG_OFF,		0.0,	ACTOR_X2,	70,								0,		0,		NULL,	MNT_INTERNATIONALTITLE1_1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE1_1,

	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_INTERNATIONALNAME2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME2
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_INTERNATIONALTITLE2_1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE2_1,

	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_INTERNATIONALNAME3,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME3
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_INTERNATIONALTITLE3,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE3,

	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_INTERNATIONALNAME4,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME4
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_INTERNATIONALTITLE4,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE4,

	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_INTERNATIONALNAME5,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME5
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_INTERNATIONALTITLE5_1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE5_1,

	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_INTERNATIONALNAME6,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME6
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_INTERNATIONALTITLE6,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE6,

	MG_OFF,		0.0,	ACTOR_X1,	250,							0,		0,		NULL,	MNT_INTERNATIONALNAME7,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME7
	MG_OFF,		0.0,	ACTOR_X2,	250,							0,		0,		NULL,	MNT_INTERNATIONALTITLE1_7,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE7,

	MG_OFF,		0.0,	ACTOR_X1,	280,							0,		0,		NULL,	MNT_FRANCEMARKETINGNAME1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_FRANCEMARKETINGNAME1
	MG_OFF,		0.0,	ACTOR_X2,	280,							0,		0,		NULL,	MNT_FRANCEMARKETINGTITLE1,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_FRANCEMARKETINGTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	310,							0,		0,		NULL,	MNT_FRANCEMARKETINGNAME2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_FRANCEMARKETINGNAME2
	MG_OFF,		0.0,	ACTOR_X2,	310,							0,		0,		NULL,	MNT_FRANCEMARKETINGTITLE2,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_FRANCEMARKETINGTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	340,							0,		0,		NULL,	MNT_FRANCEMARKETINGNAME3,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_FRANCEMARKETINGNAME3
	MG_OFF,		0.0,	ACTOR_X2,	340,							0,		0,		NULL,	MNT_FRANCEMARKETINGTITLE3,0,NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_FRANCEMARKETINGTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	370,							0,		0,		NULL,	MNT_INTERNATIONALNAME8,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME8
	MG_OFF,		0.0,	ACTOR_X2,	370,							0,		0,		NULL,	MNT_INTERNATIONALTITLE1_8,0,NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE8
	MG_OFF,		0.0,	ACTOR_X1,	400,							0,		0,		NULL,	MNT_INTERNATIONALNAME9,0,	NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_INTERNATIONALNAME9
	MG_OFF,		0.0,	ACTOR_X2,	400,							0,		0,		NULL,	MNT_INTERNATIONALTITLE1_9,0,NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_INTERNATIONALTITLE9
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN32_END

	// Screen 33
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_START
	MG_OFF,		0.0,	X_MID,		30,								0,		0,		NULL,	MNT_LOCALIZATIONDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_LOCALIZATIONDEPT
	MG_OFF,		0.0,	ACTOR_X1,	120,							0,		0,		NULL,	MNT_LOCALIZATIONNAME1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LOCALIZATIONNAME1
	MG_OFF,		0.0,	ACTOR_X2,	120,							0,		0,		NULL,	MNT_LOCALIZATIONTITLE1_1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LOCALIZATIONTITLE1_1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_LOCALIZATIONTITLE1_2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LOCALIZATIONTITLE1_2
	MG_OFF,		0.0,	ACTOR_X1,	200,							0,		0,		NULL,	MNT_LOCALIZATIONNAME2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LOCALIZATIONNAME2
	MG_OFF,		0.0,	ACTOR_X2,	200,							0,		0,		NULL,	MNT_LOCALIZATIONTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LOCALIZATIONTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_LOCALIZATIONNAME3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LOCALIZATIONNAME3
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_LOCALIZATIONTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LOCALIZATIONTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	320,							0,		0,		NULL,	MNT_LOCALIZATIONNAME4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LOCALIZATIONNAME4
	MG_OFF,		0.0,	ACTOR_X2,	320,							0,		0,		NULL,	MNT_LOCALIZATIONTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LOCALIZATIONTITLE4
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_5_START
	MG_OFF,		0.0,	X_MID,		36,								0,		0,		NULL,	MNT_QADEPT,				0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_QADEPT
	MG_OFF,		0.0,	ACTOR_X1,	80,								0,		0,		NULL,	MNT_QANAME1,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME1
	MG_OFF,		0.0,	ACTOR_X2,	80,								0,		0,		NULL,	MNT_QATITLE1,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE1
	MG_OFF,		0.0,	ACTOR_X1,	120,							0,		0,		NULL,	MNT_QANAME2,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME2
	MG_OFF,		0.0,	ACTOR_X2,	120,								0,		0,		NULL,	MNT_QATITLE2,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE2
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_QANAME3,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME3
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_QATITLE3,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE3
	MG_OFF,		0.0,	ACTOR_X1,	200,							0,		0,		NULL,	MNT_QANAME4,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME4
	MG_OFF,		0.0,	ACTOR_X2,	200,							0,		0,		NULL,	MNT_QATITLE4,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE4
	MG_OFF,		0.0,	ACTOR_X1,	240,							0,		0,		NULL,	MNT_QANAME5,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME5
	MG_OFF,		0.0,	ACTOR_X2,	240,							0,		0,		NULL,	MNT_QATITLE5,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE5
	MG_OFF,		0.0,	ACTOR_X1,	280,							0,		0,		NULL,	MNT_QANAME6,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME6
	MG_OFF,		0.0,	ACTOR_X2,	280,							0,		0,		NULL,	MNT_QATITLE6,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE6
	MG_OFF,		0.0,	ACTOR_X1,	320,							0,		0,		NULL,	MNT_QANAME7,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME7
	MG_OFF,		0.0,	ACTOR_X2,	320,							0,		0,		NULL,	MNT_QATITLE7,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE7
	MG_OFF,		0.0,	ACTOR_X1,	360,							0,		0,		NULL,	MNT_QANAME8,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME8
	MG_OFF,		0.0,	ACTOR_X2,	360,							0,		0,		NULL,	MNT_QATITLE8,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_QATITLE8
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_5_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_8_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_QATESTERS,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_QADEPT
	MG_OFF,		0.0,	ACTOR_X1,	70,								0,		0,		NULL,	MNT_QANAME9,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME9
	MG_OFF,		0.0,	ACTOR_X2,	70,								0,		0,		NULL,	MNT_QANAME10,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME10
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_QANAME11,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME11
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_QANAME12,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME12
	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_QANAME13,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME13
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_QANAME14,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME14
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_QANAME15,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME15
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_QANAME16,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME16
	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_QANAME17,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME17
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_QANAME18,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME18
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_QANAME19,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME19
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_QANAME20,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME20
	MG_OFF,		0.0,	ACTOR_X1,	250,							0,		0,		NULL,	MNT_QANAME21,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME21
	MG_OFF,		0.0,	ACTOR_X2,	250,							0,		0,		NULL,	MNT_QANAME22,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME22
	MG_OFF,		0.0,	ACTOR_X1,	280,							0,		0,		NULL,	MNT_QANAME23,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME23
	MG_OFF,		0.0,	ACTOR_X2,	280,							0,		0,		NULL,	MNT_QANAME24,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME24
	MG_OFF,		0.0,	ACTOR_X1,	310,							0,		0,		NULL,	MNT_QANAME25,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME25
	MG_OFF,		0.0,	ACTOR_X2,	310,							0,		0,		NULL,	MNT_QANAME26,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_QANAME26
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_8_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_9_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_CODERELEASEDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CODERELEASEDEPT
	MG_OFF,		0.0,	ACTOR_X1,	70,								0,		0,		NULL,	MNT_CODERELEASENAME1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CODERELEASENAME1
	MG_OFF,		0.0,	ACTOR_X2,	70,								0,		0,		NULL,	MNT_CODERELEASETITLE1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CODERELEASETITLE1
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_CODERELEASENAME2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_CODERELEASENAME2
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_CODERELEASETITLE1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_CODERELEASETITLE2

	MG_OFF,		0.0,	X_MID,		140,							0,		0,		NULL,	MNT_COMPATABILITYDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_COMPATABILITYDEPT
	MG_OFF,		0.0,	X_MID,		170,							0,		0,		NULL,	MNT_COMPATABILITYNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_COMPATABILITYNAME1
	MG_OFF,		0.0,	X_MID,		200,							0,		0,		NULL,	MNT_COMPATABILITYNAME2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_COMPATABILITYNAME2

	MG_OFF,		0.0,	X_MID,		240,							0,		0,		NULL,	MNT_NETWORKLABDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_NETWORKLABDEPT
	MG_OFF,		0.0,	X_MID,		270,							0,		0,		NULL,	MNT_NETWORKLABNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_NETWORKLABNAME1

	MG_OFF,		0.0,	X_MID,		310,							0,		0,		NULL,	MNT_INSTALLERDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_INSTALLERDEPT
	MG_OFF,		0.0,	X_MID,		340,							0,		0,		NULL,	MNT_INSTALLERNAME1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_INSTALLERNAME1
	MG_OFF,		0.0,	X_MID,		370,							0,		0,		NULL,	MNT_INSTALLERNAME2,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_INSTALLERNAME2

	MG_OFF,		0.0,	X_MID,		400,							0,		0,		NULL,	MNT_MANUALDEPT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_MANUALDEPT
	MG_OFF,		0.0,	ACTOR_X1,	430,							0,		0,		NULL,	MNT_MANUALNAME1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MANUALNAME1
	MG_OFF,		0.0,	ACTOR_X2,	430,							0,		0,		NULL,	MNT_MANUALTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,		CT_VLTPURPLE1,		NULL,	//	ECG_MANUALTITLE1
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN33_9_END


	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN34_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_MISDEPT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_MISDEPT
	MG_OFF,		0.0,	X_MID,		80,								0,		0,		NULL,	MNT_MISNAME1,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME1
	MG_OFF,		0.0,	X_MID,		110,							0,		0,		NULL,	MNT_MISNAME2,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME2
	MG_OFF,		0.0,	X_MID,		140,							0,		0,		NULL,	MNT_MISNAME3,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME3
	MG_OFF,		0.0,	X_MID,		170,							0,		0,		NULL,	MNT_MISNAME4,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME4
	MG_OFF,		0.0,	X_MID,		200,							0,		0,		NULL,	MNT_MISNAME5,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME5
	MG_OFF,		0.0,	X_MID,		230,							0,		0,		NULL,	MNT_MISNAME6,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME6
	MG_OFF,		0.0,	X_MID,		260,							0,		0,		NULL,	MNT_MISNAME7,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME7
	MG_OFF,		0.0,	X_MID,		290,							0,		0,		NULL,	MNT_MISNAME8,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME8
	MG_OFF,		0.0,	X_MID,		320,							0,		0,		NULL,	MNT_MISNAME9,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME9
	MG_OFF,		0.0,	X_MID,		350,							0,		0,		NULL,	MNT_MISNAME10,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME10
	MG_OFF,		0.0,	X_MID,		380,							0,		0,		NULL,	MNT_MISNAME11,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_MISNAME11
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN34_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN35_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_VIACOMPARAMOUNTLIASONS,	0,	NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_VIACOMPARAMOUNTLIASONS
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_LIASONSNAME1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LIASONSNAME1
	MG_OFF,		0.0,	ACTOR_X2,	140,							0,		0,		NULL,	MNT_LIASONSTITLE1_1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LIASONSTITLE1_1
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_LIASONSTITLE1_2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LIASONSTITLE1_2
	MG_OFF,		0.0,	ACTOR_X1,	270,							0,		0,		NULL,	MNT_LIASONSNAME2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LIASONSNAME2
	MG_OFF,		0.0,	ACTOR_X2,	270,							0,		0,		NULL,	MNT_LIASONSTITLE2_1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LIASONSTITLE2_1
	MG_OFF,		0.0,	ACTOR_X2,	290,							0,		0,		NULL,	MNT_LIASONSTITLE2_2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_LIASONSTITLE2_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN35_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN35_5_START
	MG_OFF,		0.0,	X_MID,		30,								0,		0,		NULL,	MNT_VIACOM,				0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_VIACOM
	MG_OFF,		0.0,	X_MID,		60,								0,		0,		NULL,	MNT_VIACOMDEPT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_VIACOMDEPT
	MG_OFF,		0.0,	X_MID,		100,							0,		0,		NULL,	MNT_VIACOMNAME1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME1
	MG_OFF,		0.0,	X_MID,		130,							0,		0,		NULL,	MNT_VIACOMNAME2,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME2
	MG_OFF,		0.0,	X_MID,		160,							0,		0,		NULL,	MNT_VIACOMNAME3,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME3
	MG_OFF,		0.0,	X_MID,		190,							0,		0,		NULL,	MNT_VIACOMNAME4,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME4
	MG_OFF,		0.0,	X_MID,		220,							0,		0,		NULL,	MNT_VIACOMNAME5,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME5
	MG_OFF,		0.0,	X_MID,		250,							0,		0,		NULL,	MNT_VIACOMNAME6,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME6
	MG_OFF,		0.0,	X_MID,		280,							0,		0,		NULL,	MNT_VIACOMNAME9,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VIACOMNAME7

	MG_OFF,		0.0,	X_MID,		345,								0,		0,		NULL,	MNT_CONSULTANT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CONSULTANT
	MG_OFF,		0.0,	ACTOR_X1,	375,							0,		0,		NULL,	MNT_CONSULTANTNAME1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CONSULTANTNAME1
	MG_OFF,		0.0,	ACTOR_X2,	375,							0,		0,		NULL,	MNT_CONSULTANTTITLE1_1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CONSULTANTTITLE1_1
	MG_OFF,		0.0,	ACTOR_X2,	395,							0,		0,		NULL,	MNT_CONSULTANTTITLE1_2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CONSULTANTTITLE1_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN35_5_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN36_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_COMPUTERRENDEREDANIMATION,0,NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_COMPUTERRENDEREDANIMATION
	MG_OFF,		0.0,	X_MID,		70,								0,		0,		NULL,	MNT_CREATDEPT,			0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CREATDEPT
	MG_OFF,		0.0,	ACTOR_X1,	90,							0,		0,		NULL,	MNT_CREATNAME1,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME1
	MG_OFF,		0.0,	ACTOR_X2,	90,							0,		0,		NULL,	MNT_CREATTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	110,							0,		0,		NULL,	MNT_CREATNAME2,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME2
	MG_OFF,		0.0,	ACTOR_X2,	110,							0,		0,		NULL,	MNT_CREATTITLE2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_CREATNAME3,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME3
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_CREATTITLE3,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	150,							0,		0,		NULL,	MNT_CREATNAME4,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME4
	MG_OFF,		0.0,	ACTOR_X2,	150,							0,		0,		NULL,	MNT_CREATTITLE4,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE4
	MG_OFF,		0.0,	ACTOR_X1,	170,							0,		0,		NULL,	MNT_CREATNAME5,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME5
	MG_OFF,		0.0,	ACTOR_X2,	170,							0,		0,		NULL,	MNT_CREATTITLE5,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE5
	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_CREATNAME6,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME6
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_CREATTITLE6,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE6
	MG_OFF,		0.0,	ACTOR_X1,	210,							0,		0,		NULL,	MNT_CREATNAME7,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME7
	MG_OFF,		0.0,	ACTOR_X2,	210,							0,		0,		NULL,	MNT_CREATTITLE7,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE7
	MG_OFF,		0.0,	ACTOR_X1,	230,							0,		0,		NULL,	MNT_CREATNAME8,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME8
	MG_OFF,		0.0,	ACTOR_X2,	230,							0,		0,		NULL,	MNT_CREATTITLE8,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE8
	MG_OFF,		0.0,	ACTOR_X1,	250,							0,		0,		NULL,	MNT_CREATNAME9,			0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME9
	MG_OFF,		0.0,	ACTOR_X2,	250,							0,		0,		NULL,	MNT_CREATTITLE9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE9
	MG_OFF,		0.0,	ACTOR_X1,	270,							0,		0,		NULL,	MNT_CREATNAME10,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME10
	MG_OFF,		0.0,	ACTOR_X2,	270,							0,		0,		NULL,	MNT_CREATTITLE10,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE10
	MG_OFF,		0.0,	ACTOR_X1,	290,							0,		0,		NULL,	MNT_CREATNAME11,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CREATNAME11
	MG_OFF,		0.0,	ACTOR_X2,	290,							0,		0,		NULL,	MNT_CREATTITLE11,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CREATTITLE11

	MG_OFF,		0.0,	X_MID,		330,								0,		0,		NULL,	MNT_OPENINGCREDITSDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_OPENINGCREDITSDEPT
	MG_OFF,		0.0,	ACTOR_X1,	350,							0,		0,		NULL,	MNT_OPENINGCREDITS_NAME,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_OPENINGCREDITS_NAME
	MG_OFF,		0.0,	ACTOR_X2,	350,							0,		0,		NULL,	MNT_OPENINGCREDITS_TITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,		NULL,	//	ECG_OPENINGCREDITS_TITLE1
	MG_OFF,		0.0,	ACTOR_X2,	370,							0,		0,		NULL,	MNT_OPENINGCREDITS_TITLE2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,		NULL,	//	ECG_OPENINGCREDITS_TITLE2

	MG_OFF,		0.0,	X_MID,		410,							0,		0,		NULL,	MNT_LOGOSEQUENCEDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_LOGOSEQUENCEDEPT
	MG_OFF,		0.0,	X_MID,		430,							0,		0,		NULL,	MNT_LOGOSEQUENCE_NAME,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_LOGOSEQUENCE_NAME
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN36_END


	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN37_START
	MG_OFF,		0.0,	X_MID,		20,								0,		0,		NULL,	MNT_VOCALTALENTS,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_VOCALTALENTS

	MG_OFF,		0.0,	X_MID,		60,								0,		0,		NULL,	MNT_CASTINGDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CASTINGDEPT
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_CASTINGNAME1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CASTINGNAME1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_CASTINGTITLE1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CASTINGTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_CASTINGNAME2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CASTINGNAME2
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_CASTINGTITLE2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CASTINGTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_CASTINGNAME3,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CASTINGNAME3
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_CASTINGTITLE3,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CASTINGTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_CASTINGNAME4,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_CASTINGNAME4
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_CASTINGTITLE4,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_CASTINGTITLE4

	MG_OFF,		0.0,	X_MID,		240,							0,		0,		NULL,	MNT_RECORDEDATDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_RECORDEDATDEPT
	MG_OFF,		0.0,	X_MID,		280,							0,		0,		NULL,	MNT_RECORDEDATNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_RECORDEDATNAME1
	MG_OFF,		0.0,	X_MID,		310,							0,		0,		NULL,	MNT_RECORDEDATNAME2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_RECORDEDATNAME2
	MG_OFF,		0.0,	X_MID,		340,							0,		0,		NULL,	MNT_RECORDEDATNAME3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_RECORDEDATNAME3

	MG_OFF,		0.0,	X_MID,		390,							0,		0,		NULL,	MNT_DIRECTORDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_DIRECTORDEPT
	MG_OFF,		0.0,	X_MID,		430,							0,		0,		NULL,	MNT_DIRECTORNAME1,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_DIRECTORNAME1
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN37_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN37_1_START
	MG_OFF,		0.0,	X_MID,		20,								0,		0,		NULL,	MNT_VOCALTALENTS,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_GERMAN_VOCALTALENTS
	MG_OFF,		0.0,	X_MID,		60,								0,		0,		NULL,	MNT_GERMAN_CASTINGDEPT,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_GERMAN_CASTINGDEPT
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_GERMAN_CASTINGNAME1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_GERMAN_CASTINGNAME1
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_GERMAN_CASTINGTITLE1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_GERMAN_CASTINGTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	130,							0,		0,		NULL,	MNT_GERMAN_CASTINGNAME2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_GERMAN_CASTINGNAME2
	MG_OFF,		0.0,	ACTOR_X2,	130,							0,		0,		NULL,	MNT_GERMAN_CASTINGTITLE2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_GERMAN_CASTINGTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_GERMAN_CASTINGNAME3,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_GERMAN_CASTINGNAME3
	MG_OFF,		0.0,	X_MID,		240,							0,		0,		NULL,	MNT_GERMAN_RECORDEDATDEPT,0,	NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_GERMAN_RECORDEDATDEPT
	MG_OFF,		0.0,	X_MID,		280,							0,		0,		NULL,	MNT_GERMAN_RECORDEDATNAME1,0,	NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_GERMAN_RECORDEDATNAME1
	MG_OFF,		0.0,	X_MID,		390,							0,		0,		NULL,	MNT_GERMAN_DIRECTORDEPT,0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_GERMAN_DIRECTORDEPT
	MG_OFF,		0.0,	X_MID,		430,							0,		0,		NULL,	MNT_GERMAN_DIRECTORNAME1,0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_GERMAN_DIRECTORNAME1
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN37_1_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN38_START
	MG_OFF,		0.0,	X_MID,		40,								0,		0,		NULL,	MNT_CREATIVESERVICES,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_CREATIVESERVICES
	MG_OFF,		0.0,	X_MID,		100,							0,		0,		NULL,	MNT_IGNITEDMINDS,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_IGNITEDMINDS
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_IGNITEDMINDS_NAME1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_IGNITEDMINDS_NAME1
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_IGNITEDMINDS_TITLE1,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_IGNITEDMINDS_TITLE1,
	MG_OFF,		0.0,	ACTOR_X1,	190,							0,		0,		NULL,	MNT_IGNITEDMINDS_NAME2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_IGNITEDMINDS_NAME2
	MG_OFF,		0.0,	ACTOR_X2,	190,							0,		0,		NULL,	MNT_IGNITEDMINDS_TITLE2,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_IGNITEDMINDS_TITLE2,
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_IGNITEDMINDS_NAME3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_IGNITEDMINDS_NAME3
	MG_OFF,		0.0,	ACTOR_X2,	220,							0,		0,		NULL,	MNT_IGNITEDMINDS_TITLE3,0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_IGNITEDMINDS_TITLE3,
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN38_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN38_5_START
	MG_OFF,		0.0,	X_MID,		30,								0,		0,		NULL,	MNT_SPECIALTHANKS,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_SPECIALTHANKS
	MG_OFF,		0.0,	X_MID,		80,								0,		0,		NULL,	MNT_ACTIVISIONDEPT,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_ACTIVISIONDEPT
	MG_OFF,		0.0,	X_MID,		105,							0,		0,		NULL,	MNT_ACTIVISIONNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME1
	MG_OFF,		0.0,	X_MID,		130,							0,		0,		NULL,	MNT_ACTIVISIONNAME2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME2
	MG_OFF,		0.0,	X_MID,		155,							0,		0,		NULL,	MNT_ACTIVISIONNAME3,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME3
	MG_OFF,		0.0,	X_MID,		180,							0,		0,		NULL,	MNT_ACTIVISIONNAME4,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME4
	MG_OFF,		0.0,	X_MID,		205,							0,		0,		NULL,	MNT_ACTIVISIONNAME5,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME5
	MG_OFF,		0.0,	X_MID,		230,							0,		0,		NULL,	MNT_ACTIVISIONNAME6,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME6
	MG_OFF,		0.0,	X_MID,		255,							0,		0,		NULL,	MNT_ACTIVISIONNAME7,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME7
	MG_OFF,		0.0,	X_MID,		280,							0,		0,		NULL,	MNT_ACTIVISIONNAME8,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME8
	MG_OFF,		0.0,	X_MID,		305,							0,		0,		NULL,	MNT_ACTIVISIONNAME12,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME9
	MG_OFF,		0.0,	X_MID,		330,							0,		0,		NULL,	MNT_ACTIVISIONNAME13,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME10
	MG_OFF,		0.0,	X_MID,		355,							0,		0,		NULL,	MNT_ACTIVISIONNAME9,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME11
	MG_OFF,		0.0,	X_MID,		380,							0,		0,		NULL,	MNT_ACTIVISIONNAME10,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME12
	MG_OFF,		0.0,	X_MID,		405,							0,		0,		NULL,	MNT_ACTIVISIONNAME11,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME13
	MG_OFF,		0.0,	X_MID,		430,							0,		0,		NULL,	MNT_ACTIVISIONNAME14,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_ACTIVISIONNAME14

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN38_5_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN39_START
	MG_OFF,		0.0,	X_MID,		180,							0,		0,		NULL,	MNT_VERYSPECIALTHANKSDEPT,0,	NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_VERYSPECIALTHANKSDEPT
	MG_OFF,		0.0,	X_MID,		220,							0,		0,		NULL,	MNT_VERSPECIALTNAME1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_VERSPECIALTNAME1
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN39_END

	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN40_START
	MG_OFF,		0.0,	X_MID,		30,								0,		0,		NULL,	MNT_XSPECIALTHANKSDEPT,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_LTGOLD1,		NULL,	//	ECG_XSPECIALTHANKSDEPT
	MG_OFF,		0.0,	ACTOR_X1,	60,								0,		0,		NULL,	MNT_XSPECIALTNAME1,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME1
	MG_OFF,		0.0,	ACTOR_X2,	60,								0,		0,		NULL,	MNT_XSPECIALTTITLE1,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE1
	MG_OFF,		0.0,	ACTOR_X1,	80,								0,		0,		NULL,	MNT_XSPECIALTNAME2,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME2
	MG_OFF,		0.0,	ACTOR_X2,	80,								0,		0,		NULL,	MNT_XSPECIALTTITLE2,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE2
	MG_OFF,		0.0,	ACTOR_X1,	100,							0,		0,		NULL,	MNT_XSPECIALTNAME3,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME3
	MG_OFF,		0.0,	ACTOR_X2,	100,							0,		0,		NULL,	MNT_XSPECIALTTITLE3,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE3
	MG_OFF,		0.0,	ACTOR_X1,	120,							0,		0,		NULL,	MNT_XSPECIALTNAME4,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME4
	MG_OFF,		0.0,	ACTOR_X2,	120,							0,		0,		NULL,	MNT_XSPECIALTTITLE4,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE4
	MG_OFF,		0.0,	ACTOR_X1,	140,							0,		0,		NULL,	MNT_XSPECIALTNAME15,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTTITLE15
	MG_OFF,		0.0,	ACTOR_X1,	160,							0,		0,		NULL,	MNT_XSPECIALTNAME13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME13
	MG_OFF,		0.0,	ACTOR_X2,	160,							0,		0,		NULL,	MNT_XSPECIALTITLE13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE13
	MG_OFF,		0.0,	ACTOR_X1,	180,							0,		0,		NULL,	MNT_XSPECIALTNAME14,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME14
	MG_OFF,		0.0,	ACTOR_X2,	180,							0,		0,		NULL,	MNT_XSPECIALTITLE13,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE14
	MG_OFF,		0.0,	ACTOR_X1,	200,							0,		0,		NULL,	MNT_XSPECIALTNAME16,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTTITLE16
	MG_OFF,		0.0,	ACTOR_X1,	220,							0,		0,		NULL,	MNT_XSPECIALTNAME17,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTTITLE17
	MG_OFF,		0.0,	ACTOR_X1,	240,							0,		0,		NULL,	MNT_XSPECIALTNAME18,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTTITLE18
	MG_OFF,		0.0,	ACTOR_X1,	260,							0,		0,		NULL,	MNT_XSPECIALTNAME5,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME5
	MG_OFF,		0.0,	ACTOR_X2,	260,							0,		0,		NULL,	MNT_XSPECIALTTITLE5,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE5
	MG_OFF,		0.0,	ACTOR_X1,	280,							0,		0,		NULL,	MNT_XSPECIALTNAME6,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME6
	MG_OFF,		0.0,	ACTOR_X2,	280,							0,		0,		NULL,	MNT_XSPECIALTTITLE6,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE6
	MG_OFF,		0.0,	ACTOR_X1,	300,							0,		0,		NULL,	MNT_XSPECIALTNAME7,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME7
	MG_OFF,		0.0,	ACTOR_X2,	300,							0,		0,		NULL,	MNT_XSPECIALTTITLE7,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE7
	MG_OFF,		0.0,	ACTOR_X1,	320,							0,		0,		NULL,	MNT_XSPECIALTNAME8,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME8
	MG_OFF,		0.0,	ACTOR_X2,	320,							0,		0,		NULL,	MNT_XSPECIALTTITLE8,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE8
	MG_OFF,		0.0,	ACTOR_X1,	340,							0,		0,		NULL,	MNT_XSPECIALTNAME9,		0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME9
	MG_OFF,		0.0,	ACTOR_X2,	340,							0,		0,		NULL,	MNT_XSPECIALTTITLE9,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE9
	MG_OFF,		0.0,	ACTOR_X1,	360,							0,		0,		NULL,	MNT_XSPECIALTNAME10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME10
	MG_OFF,		0.0,	ACTOR_X2,	360,							0,		0,		NULL,	MNT_XSPECIALTTITLE10,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE10
	MG_OFF,		0.0,	ACTOR_X1,	380,							0,		0,		NULL,	MNT_XSPECIALTNAME11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME11
	MG_OFF,		0.0,	ACTOR_X2,	380,							0,		0,		NULL,	MNT_XSPECIALTTITLE11,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE11
	MG_OFF,		0.0,	ACTOR_X1,	400,							0,		0,		NULL,	MNT_XSPECIALTNAME19,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME19
	MG_OFF,		0.0,	ACTOR_X2,	400,							0,		0,		NULL,	MNT_XSPECIALTTITLE19,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE19
	MG_OFF,		0.0,	ACTOR_X1,	420,							0,		0,		NULL,	MNT_XSPECIALTNAME20,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME20
	MG_OFF,		0.0,	ACTOR_X2,	420,							0,		0,		NULL,	MNT_XSPECIALTTITLE20,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE20
	MG_OFF,		0.0,	ACTOR_X1,	440,							0,		0,		NULL,	MNT_XSPECIALTNAME21,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME21
	MG_OFF,		0.0,	ACTOR_X2,	440,							0,		0,		NULL,	MNT_XSPECIALTTITLE21,	0,		NULL,		0,		0,		0,					0,			UI_SMALLFONT,				CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE21
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN40_END


	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN41_START
	MG_OFF,		0.0,	X_MID,		50,								0,		0,		NULL,	MNT_ANDTHANKSTO,		0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_LTGOLD1,		NULL,	//	ECG_ANDTHANKSTO
	MG_OFF,		0.0,	X_MID,		140,							0,		0,		NULL,	MNT_XSPECIALTNAME12,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_WHITE,		NULL,	//	ECG_XSPECIALTNAME12
	MG_OFF,		0.0,	X_MID,		180,							0,		0,		NULL,	MNT_XSPECIALTTITLE12_1,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE12_1
	MG_OFF,		0.0,	X_MID,		200,							0,		0,		NULL,	MNT_XSPECIALTTITLE12_2,	0,		NULL,		0,		0,		0,					0,			UI_CENTER|UI_SMALLFONT,		CT_VLTPURPLE1,	NULL,	//	ECG_XSPECIALTTITLE12_2
	MG_VAR,		0.0,	0,			0,								0,		0,		NULL,	0,						0,		NULL,		0,		0,		0,					0,			0,							CT_NONE,		NULL,	// 	ECG_SCREEN41_END


	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN_PIC_START
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/janeway.tga",		0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN1_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/chakotay.tga",		0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN2_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/torres.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN3_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/paris.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN4_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/neelix.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN5_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/doctor.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN6_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/tuvok.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN7_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/kim.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN8_PIC

	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/munro.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN9_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/munro_female",		0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN10_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/foster.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN11_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/biessman.tga",		0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN12_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/chell.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN13_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/telsia.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN14_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/chang.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN15_PIC

	MG_GRAPHIC,	0.0,	64,		30,				512,	256,	"menu/endcredits/ef_logo.tga",	0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN16_PIC
	MG_GRAPHIC,	0.0,	ACTOR_PIC_X,ACTOR_PIC_Y,128,	128,	"menu/bios/seven.tga",			0,0,		NULL,		0,		0,		0,					0,			0,						CT_WHITE,		NULL,	//	ECG_SCREEN17_PIC

	MG_VAR,		0.0,	0,		0,				0,		0,		NULL,							0,0,		NULL,		0,		0,		0,					0,			0,						CT_NONE,		NULL,	// 	ECG_SCREEN_PIC_END

};


/*
=================
ClosingCreditsMenu_Key
=================
*/
sfxHandle_t ClosingCreditsMenu_Key (int key)
{
#ifndef FINAL_BUILD
	if (key == K_F11) {
		ui.Cmd_ExecuteText(EXEC_APPEND, "screenshot\n");
		return 0;
	}
#endif
	// Advance to Main Menu
	if ((key == K_SPACE) || (key == K_ENTER) || (key == K_MOUSE1) || (key == K_ESCAPE))
	{
		if (s_closingcredits.fromMenu)
		{
			ui.Cmd_ExecuteText( EXEC_APPEND, "disconnect\n");
		}
		else
		{
			UI_PopMenu();
		}
	}

	return ( menu_out_sound);
}

void ClosingCreditsMenu_Blinkies(void)
{
	int screenI,picI;

	if ((s_closingcredits.currentScreen==1)&&(!s_closingcredits.musicStart))
	{
		//ui.S_StartLocalSound( s_closingcredits.song, CHAN_AUTO );
		ui.Cmd_ExecuteText( EXEC_APPEND,"music music/endcredits.mp3  music/briefing2.mp3\n");
		s_closingcredits.musicStart = qtrue;
	}

	if (s_closingcredits.timer < uis.realtime)
	{
		// Turnoff old screen
		screenI = endcreditsmenu_graphics[s_closingcredits.currentScreen].target;
		screenI++;

		while (endcreditsmenu_graphics[screenI].type != MG_VAR)
		{
			endcreditsmenu_graphics[screenI].type = MG_OFF;
			screenI++;
		}

		// Turnoff graphic
		if (endcreditsmenu_graphics[s_closingcredits.currentScreen].normaltextEnum)
		{
			picI = endcreditsmenu_graphics[s_closingcredits.currentScreen].normaltextEnum;
			endcreditsmenu_graphics[picI].type = MG_OFF;
		}

		s_closingcredits.currentScreen++;

		// All done
		if (s_closingcredits.currentScreen >=s_closingcredits.maxScreens)
		{
			if (s_closingcredits.fromMenu)
			{
				ui.Cmd_ExecuteText( EXEC_APPEND, "disconnect\n");
	//			UI_MainMenu();
				return;
			}
			else
			{
				UI_PopMenu();
			}
		}

		screenI = endcreditsmenu_graphics[s_closingcredits.currentScreen].target;
		screenI++;

		while (endcreditsmenu_graphics[screenI].type != MG_VAR)
		{
			endcreditsmenu_graphics[screenI].type = MG_STRING;
			screenI++;
		}

		s_closingcredits.timer = uis.realtime + endcreditsmenu_graphics[s_closingcredits.currentScreen].timer;

		endcreditsmenu_graphics[ECG_FADE].timer = 0.01f; 
		endcreditsmenu_graphics[ECG_FADEFLAG].timer = uis.realtime;

		// Turnon graphic
		if (endcreditsmenu_graphics[s_closingcredits.currentScreen].normaltextEnum)
		{
			picI = endcreditsmenu_graphics[s_closingcredits.currentScreen].normaltextEnum;
			endcreditsmenu_graphics[picI].type = MG_GRAPHIC;
		}
	}

	if (s_closingcredits.currentScreen == 0)
	{
		endcreditsmenu_graphics[ECG_FADE].timer = 0.0;
	}
	else	// Fade in text
	{
		 endcreditsmenu_graphics[ECG_FADE].timer = 
			 UI_FadeAmount( endcreditsmenu_graphics[ECG_FADEFLAG].timer, 500,UI_FADEIN );
	}

}

/*
=================
M_ClosingCreditsMenu_Graphics
=================
*/
void M_ClosingCreditsMenu_Graphics (void)
{
	ClosingCreditsMenu_Blinkies();

	UI_PrintMenuGraphics(endcreditsmenu_graphics,ECG_MAX);
}

/*
===============
ClosingCreditsMenu_Draw
===============
*/
void ClosingCreditsMenu_Draw(void)
{
	// Draw graphics particular to Main Menu
	M_ClosingCreditsMenu_Graphics();
	
	Menu_Draw( &s_closingcredits.menu );


}

/*
===============
UI_ClosingCreditsMenu_Cache
===============
*/
void UI_ClosingCreditsMenu_Cache (void)
{
	int i;

	// Precache all menu graphics in array
	UI_PrecacheMenuGraphics(endcreditsmenu_graphics,ECG_MAX);

	for (i=(ECG_SCREEN_PIC_START + 1);i<ECG_SCREEN_PIC_END;i++)
	{
		endcreditsmenu_graphics[i].type = MG_OFF;
	}

	// Set all text off
	for (i=0;i<ECG_MAX;++i)
	{
		if (endcreditsmenu_graphics[i].type == MG_STRING)
		{
			endcreditsmenu_graphics[i].type = MG_OFF;
		}
	}

	// Turn on first screen text
	endcreditsmenu_graphics[ECG_OPENING1LINE1].type = MG_STRING;
	endcreditsmenu_graphics[ECG_OPENING1LINE2].type = MG_STRING;
	endcreditsmenu_graphics[ECG_OPENING1LINE3].type = MG_STRING;
	
	//s_closingcredits.song	= ui.S_RegisterSound( "music/astrometrics.mp3" );
	if (ui.Cvar_VariableValue("com_buildscript") ) {
		ui.Cmd_ExecuteText( EXEC_APPEND,"music music/endcredits.mp3\n");
		ui.Cmd_ExecuteText( EXEC_APPEND,"music music/briefing2.mp3\n");
	}
}



/*
===============
CreditsMenu_Init
===============
*/
void ClosingCreditsMenu_Init(int fromMenu)
{
	int	picI;

	UI_ClosingCreditsMenu_Cache();

	s_closingcredits.fromMenu = fromMenu;

	s_closingcredits.menu.nitems					= 0;
	s_closingcredits.menu.draw						= ClosingCreditsMenu_Draw;
	s_closingcredits.menu.key						= ClosingCreditsMenu_Key;
	s_closingcredits.menu.fullscreen				= qtrue;
	s_closingcredits.menu.wrapAround				= qtrue;
	s_closingcredits.menu.descX						= MENU_DESC_X;
	s_closingcredits.menu.descY						= MENU_DESC_Y;
	s_closingcredits.menu.titleX					= MENU_TITLE_X;
	s_closingcredits.menu.titleY					= MENU_TITLE_Y;
	s_closingcredits.menu.titleI					= MNT_CREDITSMENU_TITLE;
	s_closingcredits.menu.footNoteEnum				= MNT_CREDITS;

	s_closingcredits.currentScreen = 0;
	s_closingcredits.timer = uis.realtime + endcreditsmenu_graphics[s_closingcredits.currentScreen].timer;
	s_closingcredits.maxScreens = 67;

	picI = endcreditsmenu_graphics[s_closingcredits.currentScreen].normaltextEnum;
	endcreditsmenu_graphics[picI].type = MG_GRAPHIC;
	s_closingcredits.musicStart = qfalse;
}



/*
===============
UI_ClosingCreditsMenu
===============
*/
void UI_ClosingCreditsMenu(int fromMenu)
{
	if (fromMenu)
	{
		ui.Cmd_ExecuteText( EXEC_APPEND, "stopsound\n" );	//	Kill all sounds currently running
	}

	ClosingCreditsMenu_Init(fromMenu); 

	UI_PushMenu( &s_closingcredits.menu );

	uis.noversion	= qtrue;
	Mouse_Hide();
}

